//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Cyberpunk.h"
#include "Mixmaster.h"
#include "Pgpmail.h"
#include "global.h"
#include "view.h"

AnsiString cretbuf;
//---------------------------------------------------------------------------
AnsiString __fastcall CpkDir()
{
   return MixDir();
}
//---------------------------------------------------------------------------
AnsiString __fastcall CpkPublicRing()
{
   return CpkDir()+"pubring.asc";
}
//---------------------------------------------------------------------------
int __fastcall CpkKeyCount(TStrings *KeyDoc)
{
   int keys=0;
   for (int i=0; i<KeyDoc->Count; i++)
      if (KeyDoc->Strings[i].Trim()==BeginPgpPubKeyBlock)
         keys++;
   return keys;
}
//---------------------------------------------------------------------------
bool __fastcall cpkdb_getnext(TStringList *key, TStrings *keylist)
{
   key->Clear();
   AnsiString keyline;
   while (keylist->Count && keylist->Strings[0].IsEmpty()) keylist->Delete(0);
   if (!keylist->Count) return false;

   while (keylist->Count)
   {
      keyline = keylist->Strings[0];
      key->Add(keyline); keylist->Delete(0);
      if (keyline==EndPgpPubKeyBlock)
         return true;
   }
   return false;
}
//---------------------------------------------------------------------------
void __fastcall CpkSortKeys(TStrings *Keys)
{
   TStringList *out = new TStringList();
   TStringList *key = new TStringList();
   while (cpkdb_getnext(key,Keys))
   {
      TStringList *keylines = new TStringList();
      keylines->Text = key->Text;
      out->AddObject(keylines->Strings[0],keylines);
   }
   Keys->Clear();
   out->Sorted = true;
   for (int i=0; i<out->Count; i++)
   {
      TStrings *next = dynamic_cast<TStringList*>(out->Objects[i]);
      if (next) { Keys->AddStrings(next); Keys->Add(""); }
   }
   delete key;
   delete out;
}
//---------------------------------------------------------------------------
void __fastcall CpkBlockToKeys(TStrings *Block)
{
   if (HasPgp())
   {
      Block->SetText(PgpArmorBlockToArmorKeys(Block->Text.c_str()));
      CpkSortKeys(Block);
   }
}
//---------------------------------------------------------------------------
void __fastcall CpkKeysToBlock(TStrings *Keys)
{
   if (HasPgp())
      Keys->SetText(PgpArmorKeysToArmorBlock(Keys->Text.c_str()));
}
//---------------------------------------------------------------------------
AnsiString __fastcall CpkRemLines(TStrings *CList)
{
   int p;
   AnsiString tmp,keyid,line,shrt,adrs,caps,clisttxt=MixDir()+CListTxt;
   TStringList *rems = new TStringList();
   if (CList==NULL && FileExists(clisttxt)) rems->LoadFromFile(clisttxt);
   else rems->Text = CList->Text;
   TStringList *lines = new TStringList();
   for (int r=0; r<rems->Count; r++)
   {
      line = rems->Strings[r].Trim();
      if (line.Pos("$remailer{")==1)
      {
         keyid = noCkeyfound;
         shrt = GetParam(1,line,"\"");
         caps = GetParam(3,line,"\"");
         adrs = GetParam(0,caps," ");
         caps = caps.SubString(adrs.Length()+2,512);
         while ((p=adrs.Pos("<"))>0 || (p=adrs.Pos(">"))>0) adrs.Delete(p,1);
         lines->Add(shrt+" "+adrs+" "+noCkeyfound+" "+caps);
      }
   }
   cretbuf = lines->Text;
   delete lines;
   delete rems;
   return cretbuf;
}
//---------------------------------------------------------------------------
#define BlkIndex(str) Block->IndexOf(str)
__fastcall TCpkKey::TCpkKey(TStrings *Key)
{
   status = ksKeyOk;
   if (Key->Count) Description = Key->Strings[0];
   int i=1; while (i<Key->Count && Key->Strings[i]!=BeginPgpPubKeyBlock) i++;
   Block = new TStringList();
   for (i=i; i<Key->Count; i++)
   {
      Block->Add(Key->Strings[i]);
      if (Key->Strings[i]==EndPgpPubKeyBlock)
         break;
   }
   if (Block->Count==0) status = ksEmptyKey; else
   if (Description.IsEmpty()) status = ksEmptyDescription; else
   if (BlkIndex(BeginPgpPubKeyBlock)<0 &&
       BlkIndex(EndPgpPubKeyBlock)<0) status = ksNoBeginNoEnd; else
   if (BlkIndex(BeginPgpPubKeyBlock)!=0) status = ksNoBegin; else
   if (BlkIndex(EndPgpPubKeyBlock)!=Block->Count-1) status = ksNoEnd;
}
//---------------------------------------------------------------------------
__fastcall TCpkKey::~TCpkKey()
{
   delete Block;
}
//---------------------------------------------------------------------------
__fastcall TCpkDb::TCpkDb(AnsiString PubRing)
{
   modified = false;
   keyring = PubRing;
   keys = new TStringList();
   if (!keyring.IsEmpty() && FileExists(keyring))
   {
      TStringList *key = new TStringList();
      TStringList *keyfile = new TStringList();
      keyfile->LoadFromFile(keyring);
      if (CpkKeyCount(keyfile)==1) CpkBlockToKeys(keyfile);

      while (cpkdb_getnext(key,keyfile)) AddKeyStrings(key);

      delete keyfile;
      delete key;
   }
   keys->Sorted = true;
}
//---------------------------------------------------------------------------
__fastcall TCpkDb::TCpkDb(TStrings *PubKeys)
{
   modified = false;
   keys = new TStringList(); keys->Sorted = true;
   if (PubKeys==NULL) return;

   keys = new TStringList();
   TStringList *key = new TStringList();
   TStringList *keylist = new TStringList();
   keylist->Text = PubKeys->Text;
   //if (CpkKeyCount(keylist)==1)
   CpkBlockToKeys(keylist);
   while (cpkdb_getnext(key,keylist)) AddKeyStrings(key);
   delete keylist;
   delete key;
}
//---------------------------------------------------------------------------
__fastcall TCpkDb::~TCpkDb()
{
   Clear();
   delete keys;
}
//---------------------------------------------------------------------------
TCpkKey* __fastcall TCpkDb::GetKey(int Pos)
{
   if (Pos<0 || Pos>=keys->Count) return NULL;
   return dynamic_cast<TCpkKey*>(keys->Objects[Pos]);
}
//---------------------------------------------------------------------------
void __fastcall TCpkDb::SaveToFile(AnsiString &FileName)
{
   TStringList *allkeys = new TStringList();
   SaveToStrings(allkeys);
   CpkKeysToBlock(allkeys);
   allkeys->SaveToFile(FileName);
   delete allkeys;
}
//---------------------------------------------------------------------------
void __fastcall TCpkDb::SaveToStrings(TStrings *Strings)
{
   Strings->Clear();
   for (int k=0; k<keys->Count; k++)
   {
      TCpkKey *key = GetKey(k);
      Strings->Add(key->Description);
      Strings->Add("");
      Strings->AddStrings(key->Block);
      Strings->Add("");
   }
}
//---------------------------------------------------------------------------
AnsiString __fastcall TCpkDb::SaveToString()
{
   TStringList *allkeys = new TStringList();
   SaveToStrings(allkeys);
   AnsiString keystr = allkeys->Text;
   delete allkeys;
   return keystr;
}
//---------------------------------------------------------------------------
int __fastcall TCpkDb::AddKeyStrings(TStrings *Key)
{
   if (Key==NULL || !Key->Count) return -1;
   TCpkKey *key = new TCpkKey(Key);
   return AddKey(key);
}
//---------------------------------------------------------------------------
int __fastcall TCpkDb::AddKey(TCpkKey *Key)
{
   if (Key==NULL) return -1;
   TStringList *keylines = new TStringList();
   keylines->Add(Key->Description);
   keylines->Add("");
   keylines->AddStrings(Key->Block);
   TCpkKey *key = new TCpkKey(keylines);
   delete keylines;
   return keys->AddObject(key->Description,key);
}
//---------------------------------------------------------------------------
int __fastcall TCpkDb::Find(TCpkKey* Key)
{
   int pos=-1;
   for (int k=0; k<keys->Count; k++)
   {
      TCpkKey *key = GetKey(k);
      if (key && Key &&
          key->Description==Key->Description &&
          key->Block->Text==Key->Block->Text)
      {
         pos = k;
         break;
      }
   }
   return pos;
}
//---------------------------------------------------------------------------
int __fastcall TCpkDb::FindDescrip(AnsiString &Descrip)
{
   int pos=-1;
   for (int k=0; k<keys->Count; k++)
   {
      TCpkKey *key = GetKey(k);
      if (key && key->Description==Descrip)
      {
         pos = k;
         break;
      }
   }
   return pos;
}
//---------------------------------------------------------------------------
int __fastcall TCpkDb::Delete(int pos)
{
   if (pos<0 || pos>=keys->Count) return -1;
   delete dynamic_cast<TCpkKey*>(keys->Objects[pos]);
   keys->Delete(pos);
   modified = true;
   return pos;
}
//---------------------------------------------------------------------------
void __fastcall TCpkDb::Clear()
{
   while (keys->Count) Delete(0);
}
//---------------------------------------------------------------------------
bool __fastcall InType1(AnsiString &remailer, TStrings *list)
{
   bool ok = false;
   for (int i=0; i<list->Count; i++)
   {
//if (remailer=="config@nym.xg.nu/admin@nym.xg.nu/send@nym.xg.nu/admin@nym.xg.nu 0x02D1ED81")
//sm(remailer+"\n"+list->Strings[i]);
      if (list->Strings[i]==remailer || list->Strings[i]=="#"+remailer)
      {
         ok = true;
         break;
      }
   }
   return ok;
}
//---------------------------------------------------------------------------
AnsiString __fastcall CpkGetNewRemailerKeys(TStrings *KeyDoc)
{
 // returns description lines of new, not disabled, keys
   AnsiString desc,ctyp1txt=MixDir()+CTyp1Txt;
   TStringList *t1 = new TStringList(); t1->Sorted = true;
   if (FileExists(ctyp1txt)) t1->LoadFromFile(ctyp1txt);
   TStringList *newkeys = new TStringList();
   TCpkDb *curdb = new TCpkDb(CpkPublicRing());
   TCpkDb *newdb = new TCpkDb(KeyDoc);
   for (int k=0; k<newdb->keys->Count; k++)
   {
      TCpkKey *key = newdb->GetKey(k);
      if (curdb->FindDescrip(key->Description)<0 && !InType1(key->Description,t1))
         newkeys->Add(key->Description);
   }
   cretbuf = newkeys->Text;
   delete newdb;
   delete curdb;
   delete newkeys;
   delete t1;
   return cretbuf;
}
//---------------------------------------------------------------------------
int __fastcall CpkAddNewRemailerKeys(TStrings *KeyDoc, TStrings *Type1)
{
   int added=0;
   // find new keys and add to curdb
   TCpkDb *curdb = new TCpkDb(CpkPublicRing());
   TCpkDb *newdb = new TCpkDb(KeyDoc);
   curdb->keys->Sorted = true;
   for (int k=0; k<newdb->keys->Count; k++)
   {
      TCpkKey *key = newdb->GetKey(k);
      if (curdb->FindDescrip(key->Description)<0 && !InType1(key->Description,Type1))
      {
         curdb->AddKey(key);
         added++;
      }
   }
   curdb->SaveToStrings(KeyDoc);
   delete newdb;
   delete curdb;
   return added;
}
//---------------------------------------------------------------------------
AnsiString __fastcall CpkType1Doubles(TStrings *type1)
{
  int t,d;
  AnsiString s,id,line;
  TStringList *dbls = new TStringList();
  // get key ids in format             keyid=qty
  //                                 0x492FC66B=2
  for (t=0; t<type1->Count; t++)
  {
    if (type1->Strings[t].Pos("#")==1) continue;
    id = GetParam(1,type1->Strings[t]," ");
    // increment value
    int c = dbls->Values[id].ToIntDef(0);
    // assign incidence count
    dbls->Values[id] = AnsiString(c+1);
  }
  // remove non-duplicate items and just keep keyids without incidence count
  d=0; while(d<dbls->Count)
  {
     s = dbls->Strings[d];
     if (s.Pos("=1")==0) dbls->Strings[d++] = s.SubString(1,s.Pos("=")-1);
     else dbls->Delete(d);
  }
  // create actual display lines
  TStringList *dubs = new TStringList();
  for (d=0; d<dbls->Count; d++)
  {
     for (t=0; t<type1->Count; t++)
     {
        line = type1->Strings[t];
        if (line.Pos(dbls->Strings[d])>0)
           dubs->Add(line);
     }
     dubs->Add("");
  }
  cretbuf = dubs->Text;
  delete dubs;
  delete dbls;
  return cretbuf;
}
//---------------------------------------------------------------------------
bool __fastcall CpkRingLineOk(AnsiString &line)
{
   return GetParam(0,line," ").Pos("@")>0 && GetParam(1,line," ").Pos("0x")==1;
}
//---------------------------------------------------------------------------
bool __fastcall CpkPopNextKey(TStrings *key, TStrings *keyring)
{
   key->Clear();
   AnsiString line;
   while (keyring->Count && keyring->Strings[0].Trim()!=BeginPgpPubKeyBlock)
      keyring->Delete(0);
   while (keyring->Count)
   {
      line = keyring->Strings[0];
      key->Add(line); keyring->Delete(0);
      if (line.Trim()==EndPgpPubKeyBlock)
         break;
   }
   return key->Count;
}
//---------------------------------------------------------------------------
bool __fastcall CpkGenType1(TStrings *type1, TStrings *cring)
{
   AnsiString line;
   // remove all but disabled keys from type1.list
   int t=0; while (t<type1->Count)
   {
      if (type1->Strings[t].SubString(1,1)!="#") type1->Delete(t);
      else t++;
   }
   // add keys from pubring.asc
   TStringList *ring = new TStringList(); ring->Text = cring->Text;
   TStringList *pops = new TStringList();
   while (CpkPopNextKey(pops,ring))
   {
      CpkBlockToKeys(pops);
      if (pops->Count)
      {
         line = pops->Strings[0];
         if (line!=BeginPgpPubKeyBlock && !InType1(line,type1))
            type1->Add(line);
      }
   }
   delete pops;
   delete ring;
   return true;
}
//---------------------------------------------------------------------------
AnsiString __fastcall GetParamSpc(int pos, AnsiString fromStr)
{
   fromStr = fromStr.Trim();
   int p = fromStr.Pos(" ");
   AnsiString prm=fromStr.Trim().SubString(1,p-1);
   if (pos>0) return GetParamSpc(pos-1,fromStr.SubString(p,256));
   return prm;
}
//---------------------------------------------------------------------------
bool __fastcall CpkOneInstance(AnsiString &ShortName, TStrings *clist)
{
   int inst=0;
   for (int i=0; i<clist->Count; i++)
      if (ShortName.LowerCase()==clist->Strings[i].LowerCase())
         inst++;
   return inst<2;
}
//---------------------------------------------------------------------------
AnsiString __fastcall CpkListKeyNotFound(TStrings *clist, TStrings *type1)
{
   TStringList *nokeys = new TStringList();
   // if a short name is in clist and not type1, add it to nokeys
   AnsiString shrt,addr,typ1,cline,tline;
   for (int c=0; c<clist->Count; c++)
   {
      bool found = false;
      cline = clist->Strings[c].Trim();
      if (!CpkListLineOk(cline)) continue;

      addr = GetParam(1,cline," ");
      for (int t=0; t<type1->Count; t++)
      {
         tline = type1->Strings[t].Trim();
         if (!CpkRingLineOk(tline)) continue;

         if (tline.Pos(addr))
         {
            found = true;
            break;
         }
      }
      if (!found) nokeys->Add(
         GetParam(0,cline," ")+"  "+GetParam(1,cline," ") // short + addr
      );
   }
   //if (modified) clist->SaveToFile(MListTxt);
   cretbuf = nokeys->Text;
   delete nokeys;
   return cretbuf;
}
//---------------------------------------------------------------------------
bool __fastcall CpkListLineOk(AnsiString &line)
{
 //"redneck  config@redneck.gacracker.org     ###***##*###      :27 100.00%"
   int l=line.Length();
   AnsiString addr = GetParamSpc(1,line);
   bool ok = addr.Pos("@");
   if (ok) ok = l && line[l-10]==':';
   if (ok) ok = l && line[l-3]=='.';
   if (ok) ok = l && line[l]=='%';
   return ok;
}
//---------------------------------------------------------------------------
/*AnsiString __fastcall CpkGenType1()
{
   char* nokeyfound="----------";
   AnsiString tmps,shrt,addr,caps,line,keyid,type1str,
      ctyp1txt=MixDir()+CTyp1Txt,clisttxt=MixDir()+CListTxt,
      cringtxt=MixDir()+CRingTxt;

   int d,t,r,i,p;
   TStringList *activ = new TStringList();
   TStringList *rlist = new TStringList();
   TStringList *type1 = new TStringList();
   TStringList *disab = new TStringList();
   // get disabled keys from type1.list
   if (FileExists(ctyp1txt)) disab->LoadFromFile(ctyp1txt);
   d=0; while (d<disab->Count)
   {
      if (disab->Strings[d].SubString(1,1)!="#") disab->Delete(d);
      else d++;
   }
   // start with the remailer stats report
   if (FileExists(clisttxt)) rlist->LoadFromFile(clisttxt);
   for (r=0; r<rlist->Count; r++)
   {
      line = rlist->Strings[r].Trim();
      if (line.Pos("$remailer{")==1) // get remailer def lines
      {
         shrt = GetParam(1,line,"\"");
         caps = GetParam(3,line,"\"");
         if ((p=caps.Pos("<"))==1) caps.Delete(p,1);
         if ((p=caps.Pos(">"))>0 ) caps.Delete(p,1);
         //addr = GetParam(0,caps," ");
         type1->Add(shrt+" "+caps);
      }
      else
      if (CpkListLineOk(line)) // get list of active remailers
      {
         activ->Add(GetParam(0,line," "));
      }
   }
   // dump all remailer defs not active in stats portion of list
   t=0; while (t<type1->Count)
   {
      if (activ->IndexOf(GetParam(0,type1->Strings[t]," "))<0) type1->Delete(t);
      else t++;
   }
   // get corresponding key id
   TStringList *keyids = new TStringList();
   keyids->SetText(PgpGetUserIdsKeyIds(cringtxt.c_str()));
   for (t=0; t<type1->Count; t++)
   {
      keyid = nokeyfound;
      type1str = type1->Strings[t];
      shrt = GetParam(0,type1str," ");
      addr = GetParam(1,type1str," ");
      for (i=0; i<keyids->Count; i++)
      {
         line = keyids->Strings[i];
         if (line.Pos(addr)>0)
         {
            keyid = "0x"+line.SubString(1,8);
            break;
         }
      }
      type1str = "";
      p=2; while (!(caps=GetParam(p,type1->Strings[t]," ")).IsEmpty())
      {
         type1str += " "+caps;
         p++;
      }
      type1->Strings[t] = shrt+" "+addr+" "+keyid+type1str;
   }
   delete keyids;
   // delete disableds in type1.list and add the actual disabled line
   for (d=0; d<disab->Count; d++)
   {
      line = disab->Strings[d].SubString(2,512);
      while ((t=type1->IndexOf(line))>=0)
         type1->Delete(t);
      type1->Add("#"+line);
   }
   // look for keys that did not have a key available
   TStringList *nokeys = new TStringList();
   for (t=0; t<type1->Count; t++)
   {
      line = type1->Strings[t];
      if (line.Pos(nokeyfound)>0 && line[1]!='#')
         nokeys->Add(GetParam(0,line," ")+" "+GetParam(1,line," "));
   }
   // inform the user of problem remailers
   if (nokeys->Count)
   {
      MsgBox(
         s("=================SOME PGP KEYS NOT FOUND=================\n")+
         s("\nYou have ")+s(nokeys->Count)+s(" remailers in your type1.list file that you do not have PGP keys\n")+
         s("for. Please have a look. You've got 3 options.\n\n")+
         s("1) If you updated your pubring.asc from the same source as your current\n")+
         s("rlist.txt, you will more than likely get that key. 2) You can leave them 'as is'.\n")+
         s("They won't be used, until a key is found, but I'll nag you with this dialog,\n")+
         s("after updates. 3) You can disable them with a pound sign '#' in front of those\n")+
         s("remailers in the type1.list file. In that case, I won't nag you, but I won't add\n")+
         s("those new keys when I find them, either.\n \n \n")+
         nokeys->Text+s("\n \n \n"),
         "TYPE1.LIST",
         MB_OK
      );
   }
   delete nokeys;

   AnsiString type1lines = type1->Text;
   delete disab;
   delete type1;
   delete activ;
   return type1lines.c_str();
}
*/

