#define _WINSOCKAPI_      // Prevent winsock.h from being included
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "FileWin.h"
#include "FileMan.h"
#include "Global.h"
#include "pgpmail.h"
#include "mixmaster.h"
#include "cyberpunk.h"
#include "httpdlg.h"
#include "helpdlg.h"
//---------------------------------------------------------------------------
#pragma link "NoteWin"
#pragma link "explbtn"
#pragma resource "*.dfm"
TTextFileWin *TextFileWin;
//---------------------------------------------------------------------------
void __fastcall EditTextFile(AnsiString &FileName, TForm *Owner)
{
   AnsiString s,fn=FileName,
      ctyp1txt=MixDir()+CTyp1Txt,cringtxt=MixDir()+CRingTxt,
      mtyp2txt=MixDir()+MTyp2Txt;
   Application->MainForm->Cursor = crHourGlass;
   TStringList *lines = new TStringList();
   lines->LoadFromFile(fn);
   if (fn==cringtxt && HasPgp())
   {  // special handling of pubring.asc
      CpkBlockToKeys(lines);
   }
   else
   if (fn==ctyp1txt && HasPgp())
   {  // special handling of type1.list
      if (lines->Count)
      {
         lines->Sorted = true;
         bool ok=false;
         for (int i=0; i<lines->Count; i++)
            if (lines->Strings[i].SubString(1,1)!="#")
               ok = true;
         lines->Sorted = false;
         if (ok) while (lines->Strings[0].SubString(1,1)=="#")
         {
            s = lines->Strings[0];
            lines->Delete(0);
            lines->Add(s);
         }
      }
   }
   else
   if (fn==mtyp2txt && HasMix())
   {  // special handling of type2.list
      if (lines->Count)
      {
         lines->Sorted = true;
         bool ok=false;
         for (int i=0; i<lines->Count; i++)
            if (lines->Strings[i].SubString(1,1)!="#")
               ok = true;
         lines->Sorted = false;
         if (ok) while (lines->Strings[0].SubString(1,1)=="#")
         {
            s = lines->Strings[0];
            lines->Delete(0);
            lines->Add(s);
         }
      }
   }

   if (fn==cringtxt || fn==ctyp1txt || fn==mtyp2txt) EditFileText(lines,fn);
   else TextFileWin = new TTextFileWin(fn,Owner);

   Application->MainForm->Cursor = crDefault;
   delete lines;
}
//---------------------------------------------------------------------------
bool __fastcall TTextFileWin::Save()
{
   AnsiString fn=filename,
      cringtxt=MixDir()+CRingTxt,clisttxt=MixDir()+CListTxt,ctyp1txt=MixDir()+CTyp1Txt,
      mringtxt=MixDir()+MRingTxt,mlisttxt=MixDir()+MListTxt,mtyp2txt=MixDir()+MTyp2Txt;
   int bakcopies=STATSBAKCOPIES;
   Application->MainForm->Cursor = crHourGlass;
   TStringList *lines = new TStringList();
   lines->Text = Editor->Lines->Text;

   // special handling of pubring.asc doc--convert to single block
   if (HasPgp() && fn==cringtxt) // needsPgp...very important
   {
      TStringList *type1 = new TStringList();
      if (FileExists(cringtxt)) type1->LoadFromFile(cringtxt);
      {
         CpkGenType1(type1,lines); // generate new type1
         SaveToFileBak(lines,fn,bakcopies);
      }
      CpkKeysToBlock(lines);
   }
   // special handling of pubring.mix do
   if (HasMix() && fn==mringtxt)
   {
      TStringList *type2 = new TStringList();
      if (FileExists(mringtxt)) type2->LoadFromFile(mringtxt);
      {
         MixGenType2(type2,lines); // generate new type2
         SaveToFileBak(lines,fn,bakcopies);
      }
   }
   // save the document===============================
   if (fn==cringtxt || fn==clisttxt || fn==mringtxt || fn==mlisttxt)
      SaveToFileBak(lines,fn,bakcopies);
   else
      lines->SaveToFile(fn);
   //==========================

   Application->MainForm->Cursor = crDefault;
   delete lines;
   return true;
}
//---------------------------------------------------------------------------
void __fastcall EditFileText(TStrings *Text, AnsiString &FileName, TForm *Owner)
{
   TextFileWin = new TTextFileWin(Text,FileName,Owner);
   if (ExtractFileName(FileName)==MTyp2Txt || ExtractFileName(FileName)==CTyp1Txt)
      TextFileWin->CheckBox1->Visible = true;
}
//---------------------------------------------------------------------------
__fastcall TTextFileWin::TTextFileWin(TComponent* Owner)
  : TTextWin(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TTextFileWin::TTextFileWin(AnsiString &Filename, TComponent* Owner)
  : TTextWin(Owner)
{
   Editor->WordWrap = false;
   EditWordWrapItem->Checked = false;
   filename = Filename;
   if (FileExists(filename))
   {
      TStringList *txt = new TStringList();
      txt->LoadFromFile(filename);
      SetText("...\\"+ExtractFileName(Filename),txt);
      delete txt;
   }
   if (Filename==MixDir()+MixCfg)
   {
      TStrings *lines = Editor->Lines;
      while (lines->Count && lines->Strings[lines->Count-1].IsEmpty())
         lines->Delete(lines->Count-1);
      lines->Add("");
      if (!lines->Text.LowerCase().Pos("distance")) lines->Add("DISTANCE 2");
      if (!lines->Text.LowerCase().Pos("minrel")) lines->Add("MINREL 98");
      if (!lines->Text.LowerCase().Pos("relfinal")) lines->Add("RELFINAL 99");
      if (!lines->Text.LowerCase().Pos("maxlat")) lines->Add("MAXLAT 36h");
      lines->SaveToFile(Filename);
      Editor->Modified = false;
      HelpBtn->Visible = true;
   }
   Editor->SelStart = 0;
   FormResize(NULL);
}
//---------------------------------------------------------------------------
__fastcall TTextFileWin::TTextFileWin(TStrings *Txt, AnsiString &Filename, TComponent* Owner)
  : TTextWin(Owner)
{
   Editor->WordWrap = false;
   EditWordWrapItem->Checked = false;
   filename = Filename;
   SetText(ExtractFileName(Filename),Txt);
   if (Filename==MixDir()+MixCfg)
   {
      TStrings *lines = Editor->Lines;
      while (lines->Count && lines->Strings[lines->Count-1].IsEmpty())
         lines->Delete(lines->Count-1);
      lines->Add("");
      if (!lines->Text.LowerCase().Pos("distance")) lines->Add("DISTANCE 2");
      if (!lines->Text.LowerCase().Pos("minrel")) lines->Add("MINREL 98");
      if (!lines->Text.LowerCase().Pos("relfinal")) lines->Add("RELFINAL 99");
      if (!lines->Text.LowerCase().Pos("maxlat")) lines->Add("MAXLAT 36h");
      lines->SaveToFile(Filename);
      Editor->Modified = false;
      HelpBtn->Visible = true;
   }
   ActiveControl = Editor;
   Editor->SelStart = 0;
   FormResize(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TTextFileWin::SortTypeList(bool DisabledAtBottom)
{
   TStringList *lines = new TStringList(); lines->Sorted = true;
   lines->AddStrings(Editor->Lines);
   if (lines->Count)
   {
      bool ok=false;
      if (DisabledAtBottom)
      {
         lines->Sorted = false;
         for (int i=0; i<lines->Count; i++)
            if (lines->Strings[i].SubString(1,1)!="#")
               ok = true; // make sure not all lines begin "#'
         if (ok) while (lines->Strings[0].SubString(1,1)=="#")
         {
            AnsiString s = lines->Strings[0];
            lines->Delete(0);
            lines->Add(s);
         }
      }
   }
   Editor->Lines->Text = lines->Text;
}
//---------------------------------------------------------------------------
bool __fastcall TTextFileWin::SaveAs()
{// not needed but placed for safety
   return false;
}
//---------------------------------------------------------------------------
void __fastcall TTextFileWin::SetText(AnsiString &Name, TStrings *Text)
{
//   IndexStr = Name;
//   DataKey = UserNotes+PS+Name;
   Caption = Name;
   Editor->OnSelectionChange = NULL;
   Editor->Lines->Text = Text->Text;
   Editor->Modified = false;
   Editor->SelStart = 0;
   Editor->OnSelectionChange = EditorSelectionChange;
   ShowCurXY(true);
}
//---------------------------------------------------------------------------
bool __fastcall TTextFileWin::CheckSave()
{
   bool ok = true;
   if (Editor->Modified)
   {
      int reply = MsgBoxHwnd(Handle,
            ExtractFileName(filename).UpperCase()+" has been modified. Changes will be lost!\n\nSave it now?",
               "Save File",MB_YESNOCANCEL);
      switch(reply)
      {
         case IDCANCEL: ok = false; break;
         case IDYES: Save(); break;
      }
   }
   return ok;
}
//---------------------------------------------------------------------------
void __fastcall TTextFileWin::CheckBox1Click(TObject *Sender)
{
   bool mod = Editor->Modified;
   if (CheckBox1->Checked) SortTypeList(true);
   else SortTypeList(false);
   Editor->Modified = mod;
}
//---------------------------------------------------------------------------
void __fastcall TTextFileWin::FormResize(TObject *Sender)
{
   if (HelpBtn->Visible) HelpBtn->Left = Width - 71;
}
//---------------------------------------------------------------------------
void __fastcall TTextFileWin::HelpBtnClick(TObject *Sender)
{
   if (filename==MixDir()+MixCfg)
   {
      OpenHelp("Config","Mixmaster Configuration","",AppMainForm);
   }
}
//---------------------------------------------------------------------------
