//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\comctrls.hpp>
#include <vcl\registry.hpp>
#include <vcl\filectrl.hpp>
#pragma hdrstop

#include "Global.h"
#include "view.h";
bool DoMyBeep = true;
//---------------------------------------------------------------------------
void __fastcall SetRedraw(TWinControl *window, bool set)
{
   if (!set) window->Perform(WM_SETREDRAW,false,0);
   else
   {
      Application->ProcessMessages();
      window->Perform(WM_SETREDRAW,true,0);
      RedrawWindow(window->Handle,NULL,NULL,RDW_INVALIDATE|RDW_ALLCHILDREN);
   }
}
//---------------------------------------------------------------------------
AnsiString __fastcall QSHelp()
{
   if (FileExists(QShelp)) return QShelp;
   return AppDir+"\\doc\\"+ExtractFileName(QShelp);
}
//---------------------------------------------------------------------------
AnsiString __fastcall bak(AnsiString &name, int baknumber)
{
   AnsiString ext=ExtractFileExt(name),fname = ChangeFileExt(name,"");
   return fname+"-bak-"+AnsiString(baknumber)+ext;
}
//---------------------------------------------------------------------------
void __fastcall BufSaveToFileBak(byte* buffer, int length, AnsiString &docname, int bakcopies)
{
   for (int i=bakcopies; i>=1; i--)
   {
      if (FileExists(bak(docname,i))) DeleteFile(bak(docname,i).c_str());
      if (FileExists(bak(docname,i-1)))
          rename(bak(docname,i-1).c_str(),bak(docname,i).c_str());
   }
   if (FileExists(docname))
      rename(docname.c_str(),bak(docname,1).c_str());
   TFileStream *f = new TFileStream(docname,fmOpenWrite);
   f->WriteBuffer(buffer,length);
   delete f;
}
//---------------------------------------------------------------------------
void __fastcall SaveToFileBak(TStrings *Document, AnsiString &docname, int bakcopies)
{
   for (int i=bakcopies; i>=1; i--)
   {
      if (FileExists(bak(docname,i))) DeleteFile(bak(docname,i).c_str());
      if (FileExists(bak(docname,i-1)))
          rename(bak(docname,i-1).c_str(),bak(docname,i).c_str());
   }
   if (FileExists(docname))
      rename(docname.c_str(),bak(docname,1).c_str());
   Document->SaveToFile(docname);
}
//---------------------------------------------------------------------------
void __fastcall FileSaveToFileBak(AnsiString &tmpfile, AnsiString &docname, int bakcopies)
{
   for (int i=bakcopies; i>=1; i--)
   {
      if (FileExists(bak(docname,i))) DeleteFile(bak(docname,i).c_str());
      if (FileExists(bak(docname,i-1)))
          rename(bak(docname,i-1).c_str(),bak(docname,i).c_str());
   }
   if (FileExists(docname)) rename(docname.c_str(),bak(docname,1).c_str());
   if (FileExists(tmpfile)) rename(tmpfile.c_str(),docname.c_str());
}
//---------------------------------------------------------------------------
TColor __fastcall GetColor16(int Index)
{
   TColor WorkspaceColors[16] = { clBlack,clMaroon,clGreen,clOlive,clNavy,clPurple,
   clTeal,clGray,clSilver,clRed,clLime,clYellow,clBlue,clFuchsia,clAqua,clWhite };
   return Index<0||Index>15 ? clWhite:WorkspaceColors[Index];
}
//---------------------------------------------------------------------------
void __fastcall ClearString(AnsiString &str)
{
   for (int i=1; i<=str.Length(); i++) str[i]==' ';
   str = "";
}
//---------------------------------------------------------------------------
AnsiString __fastcall GetLastErrorStr()
{
   DWORD result = GetLastError();
   LPVOID lpMsgBuf;
   FormatMessage(
      FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
      NULL,
      result,
      MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
     (LPTSTR) &lpMsgBuf,
      0,
      NULL
   );
   return AnsiString((char*)lpMsgBuf);
}
//---------------------------------------------------------------------------
bool __fastcall SetRunOnce(const AnsiString Name, const AnsiString RunCmd)
{
   AnsiString RunOnceKey = "Software\\Microsoft\\Windows\\CurrentVersion\\RunOnce";

   TRegistry* reg = new TRegistry; reg->LazyWrite = false;
   reg->RootKey = HKEY_LOCAL_MACHINE;
   if (!reg->OpenKey(RunOnceKey, false))
   {
      reg->RootKey = HKEY_CURRENT_USER;
      if (!reg->OpenKey(RunOnceKey,false))
      {
         delete reg; return false;
      }
   }
   reg->WriteString(Name,RunCmd);
   reg->CloseKey();
   delete reg;
   return true;
}
//---------------------------------------------------------------------------
/*bool DiskInDrive(char drive)
{
   unsigned char iDrive;
   struct dfree free; bool result(false); // check to see if the drive is a letter of the alphabet
   if (!isalpha(drive))
   {
      ShowMessage("Not a valid drive id"); return false;
   } // If the drive is in upper case make it correspond to a drive where A = 1, B = 2, etc.
   if(isupper(drive))
      iDrive = (unsigned char)(drive - 0x40);
   else
      iDrive = (unsigned char)(drive - 0x60); // Turn off critical errors
   unsigned int ErrorMode = SetErrorMode(SEM_FAILCRITICALERRORS);
   try {
      getdfree(iDrive, &free);
      result = free.df_sclus != -1;
   } catch (...) { // restore old error mode
      SetErrorMode(ErrorMode);
   } return result;
}
*///---------------------------------------------------------------------------
void __fastcall MyBeep(WORD BeepType)
{
   if (DoMyBeep) MessageBeep(BeepType);
}
//---------------------------------------------------------------------------
bool __fastcall DeleteDirectory(AnsiString &pathname)
{
   if (pathname.IsEmpty() || !DirectoryExists(pathname)) return false;
   int i;
   TSearchRec sr;
   AnsiString del;
   pathname = AddBackslash(pathname);
   TStringList *dirs = new TStringList();
   TStringList *files = new TStringList();
   int done = FindFirst(pathname+"*.*",faAnyFile,sr);
   while (!done)
   {
      if (sr.Name != "." && sr.Name != "..")
      {
         del = pathname+sr.Name;
         if (sr.Attr!=faDirectory) files->Add(del.LowerCase());
         else dirs->Add(del.LowerCase());
      }
      done = FindNext(sr);
   }
   // remove directories
   for (i=0; i<dirs->Count; i++)
   {
      del = GetShortFileName(dirs->Strings[i]);
      if (!DeleteDirectory(del.c_str())) ;
//         MsgBox("Unable to delete directory:\n"+del,"Problem",MB_OK);
   }
   // remove files
   for (i=0; i<files->Count; i++)
   {
      del = files->Strings[i];
      if (!DeleteFile(del.c_str())) ;
//         MsgBox("Unable to delete file: "+del,"Problem",MB_OK);
   }
   delete files;
   delete dirs;
   return RemoveDirectory(pathname.c_str());
}
//---------------------------------------------------------------------------
HINSTANCE __fastcall ExploreFolder(AnsiString &strFolder)
{
   HINSTANCE hInst;
 //hInst = ShellExecute(NULL,"explore",strFolder.c_str(),NULL,NULL,SW_SHOWNORMAL);
   hInst = Exec95("explorer.exe "+strFolder);
   return hInst;
}
//---------------------------------------------------------------------------
HANDLE __fastcall Exec95(const AnsiString& strCmdLine, const WORD ShowCmd)
{
   STARTUPINFO siStartInfo; 					// Set up members of STARTUPINFO structure
   PROCESS_INFORMATION piProcInfo;
   siStartInfo.cb = sizeof(STARTUPINFO);
   siStartInfo.lpReserved = NULL;
   siStartInfo.lpDesktop = NULL;
   siStartInfo.lpTitle = NULL;
   siStartInfo.wShowWindow = ShowCmd;
   siStartInfo.lpReserved2 = NULL;
   siStartInfo.cbReserved2 = 0;
   siStartInfo.dwFlags = STARTF_USESHOWWINDOW;
   CreateProcess(NULL,   	      // Create the child process
      strCmdLine.c_str(),
      NULL, 	                  // process security attributes
      NULL, 							// primary thread security attributes
      0, 								// handles are inherited
      0, 								// creation flags
      NULL, 							// use parent's environment
      NULL, 							// use parent's current directory
     &siStartInfo, 					// STARTUPINFO pointer
     &piProcInfo
   ); 								   // receives PROCESS_INFORMATION
 	 return piProcInfo.hProcess;
}
//---------------------------------------------------------------------------
DWORD __fastcall ExecAndWait95(const AnsiString& strCmdLine,const WORD ShowCmd)
{
   DWORD rc;
   HANDLE handle = Exec95(strCmdLine,ShowCmd);
   do {
      rc = WaitForSingleObject(handle,100);
      Application->ProcessMessages();
   } while (rc==WAIT_TIMEOUT);
   return rc;
}
//---------------------------------------------------------------------------
bool __fastcall RegKeyExists(AnsiString &Key)
{
   TRegistry *reg = new TRegistry();
   bool exists = reg->KeyExists(Key);
   delete reg;
   return exists;
}
//---------------------------------------------------------------------------
HRESULT CreateLink(AnsiString TargetPath, AnsiString LinkPath, AnsiString IconPath,
   AnsiString Description, AnsiString Params)
{
    HRESULT hres;
    IShellLink* psl;

    CoInitialize(NULL);
    // Get a pointer to the IShellLink interface.
    hres = CoCreateInstance((_GUID)CLSID_ShellLink, NULL,CLSCTX_INPROC_SERVER,
                            (_GUID)IID_IShellLink,
                            (void**)&psl
    );
    if (SUCCEEDED(hres))
    {
        IPersistFile* ppf;
        // Set the path to the shortcut target, and add the
        // description.
        AnsiString WorkDir = ExtractFilePath(TargetPath).LowerCase();
        psl->SetPath((LPCSTR)TargetPath.c_str());
        psl->SetDescription((LPCSTR)Description.c_str());
        psl->SetWorkingDirectory((LPCSTR)WorkDir.c_str());
        psl->SetIconLocation((LPCSTR)IconPath.c_str(),0);
        if (!Params.IsEmpty())
           psl->SetArguments((LPCSTR)Params.c_str());

       //Query IShellLink for the IPersistFile interface
       //for saving the shortcut in persistent storage.
        hres = psl->QueryInterface((_GUID)IID_IPersistFile,(void**)&ppf);

        if (SUCCEEDED(hres)) {
            WORD wsz[MAX_PATH];
            // Ensure that the string is ANSI.
            MultiByteToWideChar(CP_ACP, 0, LinkPath.c_str(), -1,(wchar_t*)wsz,MAX_PATH);
            // Save the link by calling IPersistFile::Save.
            hres = ppf->Save((wchar_t*)wsz, TRUE);
            ppf->Release();
        }
        psl->Release();
    }
    return hres;
}
//---------------------------------------------------------------------------
void __fastcall CopyFile(AnsiString &destname, AnsiString &srcname)
{
   if (!FileExists(srcname)) return;
   TMemoryStream *ms = new TMemoryStream();
   ms->LoadFromFile(srcname);
   ms->SaveToFile(destname);
   delete ms;
}
//---------------------------------------------------------------------------
AnsiString __fastcall AddBackslash(AnsiString path)
{
   if (path.Length() && path.SubString(path.Length(),1)!="\\") path+="\\";
   return path;
}
//---------------------------------------------------------------------------
AnsiString __fastcall RemoveBackslash(AnsiString path)
{
   if (path.SubString(path.Length(),1)=="\\")
      path.SetLength(path.Length()-1);
   return path;
}
//---------------------------------------------------------------------------
AnsiString __fastcall GetShortFileName(AnsiString &FileName)
{
   char *shortname=NULL;
   int size = GetShortPathName(FileName.c_str(),shortname,0);
   shortname = new char[size+1];
   GetShortPathName(FileName.c_str(),shortname,size);
   AnsiString name(shortname);
   delete shortname;
   return name;
}
//---------------------------------------------------------------------------
AnsiString __fastcall GetWindowsDir()
{
   char *windir=NULL;
   int size = GetWindowsDirectory(windir,0); windir = new char[size+1];
   GetWindowsDirectory(windir,size);
   AnsiString dir(windir);
   delete windir;
   return dir;
}
//---------------------------------------------------------------------------
AnsiString __fastcall GetTempDir()
{
   char *tmpdir = NULL;
   int size = GetTempPath(0,tmpdir); tmpdir = new char[size+1];
   GetTempPath(size,tmpdir);
   AnsiString dir(tmpdir);
   delete tmpdir;
   return dir;
}
//---------------------------------------------------------------------------
void __fastcall PasteFromClipboard(TRichEdit *Editor)
{
   AnsiString s;
   TMemo *m = new TMemo((void*)NULL);
   m->WordWrap = false;
   m->Visible = false;
   m->Parent = Application->MainForm;
   m->PasteFromClipboard();
   // try this for fix of double spaced
   Editor->SelText = m->Lines->Text;
   delete m;
}
//---------------------------------------------------------------------------
AnsiString __fastcall GetParam(int pos, AnsiString &fromBuf, char *divider, char *def)
{
   int p;
   AnsiString prm,str(fromBuf),div(divider);
   for (int i = 0; i <= pos; i++)
   {
      do {
         p = str.Pos(div); if (!p) p = str.Length()+1;
         prm = str.SubString(1,p-1);
         str = str.SubString(p+div.Length(),str.Length());
      }
      while (!prm.Length() && str.Length());
   }
   return prm.IsEmpty() ? AnsiString(def):prm;
}
//---------------------------------------------------------------------------
AnsiString __fastcall GetToken(int position, char* buffer, char delimiter)
{
   return "";
}
/*
AnsiString __fastcall GetToken(int position, char* buffer, char delimiter)
{
   int beg,end;
   TList *dlims = new TList();
   for (int i=1; i<=buffer.Length(); i++)
   {
      if (buffer[i]==delimiter)) dlims->Add(i);
      if (dlims->Count>position)
      {
         int ofs = buffer[1]==delimiter ? 2 : 1;
         beg = delims->Items[pos]
         break;
      }
   }
   delete dlims;
   return buffer.SubString(first,last);
}
*/
//---------------------------------------------------------------------------
int __fastcall GetFilenames(TStrings *names, AnsiString &pathname, int attrib)
{
   if (names) names->Clear();
   TSearchRec sr;
   TStringList *Names = new TStringList();
   int done = FindFirst(pathname,attrib,sr);
   while (!done)
   {
      if (sr.Name != "." && sr.Name != "..")
         Names->Add(ExtractFilePath(pathname)+sr.Name);
      done = FindNext(sr);
   }
   if (names) names->Text = Names->Text;
   int count = Names->Count;
   delete Names;
   return count;
}
//---------------------------------------------------------------------------
void __fastcall CenterDialog(TForm *CenteredForm, TForm *MainForm)
{
   if (!MainForm) return;
   TForm *MF = MainForm;
   TForm *CF = CenteredForm;
   CF->Top = MF->Top+((MF->Height-CF->Height)/2);
   CF->Left = MF->Left+((MF->Width-CF->Width)/2);
}
//---------------------------------------------------------------------------

