#define _WINSOCKAPI_
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\registry.hpp>
#include <vcl\clipbrd.hpp>
#pragma hdrstop

#include "MainMDI.h"
#include "NoteWin.h"
#include "NoteWin1.h"
#include "FileWin.h"
#include "MsgWin.h"
#include "MsgInWin.h"
#include "RptWin.h"
#include "MBoxWin.h"
#include "SmtpDlg.h"
#include "HttpDlg.h"
#include "SaveDlg.h"
#include "OpenDlg.h"
#include "MailDlg.h"
#include "PackDlg.h"
#include "AboutDlg.h"
#include "Fmxutils.h"
#include "AddrsDlg.h"
#include "HeadMan.h"
#include "Global.h"
#include "PgpPassEx.h"
#include "Wiper.h"
#include "Version.h"
#include "GetStrtDlg.h"
#include "mixmaster.h"
#include "mixmastdlg.h"
#include "MixInstDlg.h"
#include "PreferDlg.h"
#include "ClipReply.h"
#include "NNameDlg.h"
#include "pop3mail.h"
#include "pgpmail.h"
#include "helpdlg.h"
#include "importDlg.h"
#include "deldocsdlg.h"
#include "UPDateDlg.h"
#include "pgpfiles.h"
#include "view.h"
//---------------------------------------------------------------------------
#pragma link "explbtn"
#pragma resource "*.dfm"
TMainForm *MainForm;
TDataBuf *MasterPassword;
//bool MessageTesting=false;
const bool sorted = 1;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
  : TForm(Owner)
{
   AnsiString pswd;
   // lets make sure we're in home dir
   if (GetCurrentDir()!=AppDir) SetCurrentDir(AppDir);

   MasterPassword = NULL;
   Caption = AppName+" "+ReleaseVer;
   Application->Title = AppName.Trim();
   if (!CheckAppiniExists()) ExitProcess(0);
   // try to load libeay32.dll -- unknown problem doing it later
   hSSLLib = LoadLibrary(AnsiString(MixDir()+"libeay32.dll").c_str());
   bool shutdown=false;
   hMixLib = CheckMixmasterInstall(shutdown);
   if (shutdown)
   {
      SafeStoreMixRandBin();
      Application->ShowMainForm = false;
      PostMessage(this->Handle,WM_QUIT,0,NULL);
      return;
   }
   if ((hPgpLib=CheckQSPgpInstall())>0)
      PgpInit(hMixLib,hSSLLib,this,Application->Handle);
   hPopLib = CheckQSPop3Install();
   MasterPassword = new TDataBuf();
   if (!IsEncrypted() && (!FileExists(AppDat) || GetFileSize(AppDat)==0))
   {
      if (FileExists(AppPgp))
      {
         if (!HasMixmaster())
         {
            MsgBoxHwnd(NULL,
               "Mixmaster is not available.\nCannot decrypt datafile!\n\nQuitting",
                AppName,
                MB_OK
            );
            delete MasterPassword;
            ExitProcess(0);
         }
         else
         if (PGPgetDecryptionPassphrase(pswd,NULL))
         {
            MasterPassword->SetData(pswd.c_str(),pswd.Length());
            for (int i=1; i<=pswd.Length(); i++) pswd[i] = ' '; pswd = "";
            if (!UnSecureData(MasterPassword))
            {
               MsgBoxHwnd(NULL,
                 "Unable to open datafile: "+ExtractFileName(AppPgp)+"  Quitting!",
                  AppName,
                  MB_OK
               );
               delete MasterPassword;
               ExitProcess(0);
            }
         }
         else
         {
            delete MasterPassword;
            ExitProcess(0);
         }
      }
      else  // create new dat file copying qs.ini
      {
         if (FileExists(AppIni))
         {
            TMemoryStream *ms = new TMemoryStream();
            ms->LoadFromFile(AppIni);
            ms->SaveToFile(AppDat);
            delete ms;
         }
      }
   }
   DatTime = FileExists(AppDat) ? FileDateTime(AppDat):(TDateTime)0;

   // initialize window position
   TWindowState winstate=wsNormal;
   TRegistry *reg = new TRegistry();
   if (reg->OpenKey(QuickKey,false))
   {
      winpos = reg->ReadString("WindowPos");
      winstate = (TWindowState)reg->ReadInteger("WindowState");
      if (reg->ValueExists("Update")) // <--new release: first run
      {
         reg->DeleteValue("Update");
      // add code for first run purposes (on update, not new install)
      // this adds new release number to bugreport
      }
   }
   delete reg;
   // initialize window position
   if (winpos.IsEmpty()) winpos="-1,-1,565,350";
   Left   = GetParam(0,winpos,",").ToIntDef(-1);
   Top    = GetParam(1,winpos,",").ToIntDef(-1);
   Width  = GetParam(2,winpos,",").ToIntDef(565);
   Height = GetParam(3,winpos,",").ToIntDef(350);
   // adjust position to screen if something is out of wak
   if (Height > Screen->Height) Height = Screen->Height;
   if (Width > Screen->Width) Width = Screen->Width;
   if (Left+Width > Screen->Width) Left = Screen->Width-Width;
   if (Top+Height > Screen->Height-28) Top = Screen->Height-28-Height;
   if (Left < -1) Left = -1;
   if (Top < -1) Top = -1;
   WindowState = winstate;

   StatusBar->Panels->Items[0]->Text = "";
   StatusBar->Panels->Items[1]->Text = "";
   UpdateStatsBox->Checked = GetAppIni(IniUpdateOnSend,"1").ToIntDef(0);
   ToolsUpdateonSendItem->Checked = UpdateStatsBox->Checked;
   OpenDialog->InitialDir = AppDir;
   SaveDialog->InitialDir = AppDir;
   Application->OnHint = &ShowHint;
   OpenQueueBtn->Enabled = AppDataExists(MailQueue);
   OpenProbsBtn->Enabled = AppDataExists(ProblemQueue);

   ProcessLog = new TStringList();
   ErrorLog = new TStringList();

   LoadMailboxMenu();
   SetMenus();
   HeadMan = new THeaderManager();

   if (!RegKeyExists(MixKey) || !hMixLib)
      SetNoMixmaster();

   OpenDialog->Filter = "All files (*.*)|*.*";
   OpenDialog->InitialDir = AppDir;

   MixPoolClear();

// swap over to 'drafts' from 'messages'
   if (AppDataExists(WasUserMessages))
   {
      if (!AppDataExists(UserMessages))
         RenameAppIndex(WasUserMessages,UserMessages);
      if (AppDataExists(WasUserMessages)) PutAppData(WasUserMessages,NULL);
   }

   Color = (TColor)GetAppIni(WorkSpaceColor,"").ToIntDef(clTeal);
   //PasteBtn->Enabled = false;
   //CopyBtn->Enabled = false;
   //CutBtn->Enabled = false;
   OptionsBtn->Visible = FileExists(ChangeFileExt(AppExeName,".dsk"));
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   // save window state information
   TRegistry *reg = new TRegistry();
   if (reg->OpenKey(QuickKey,false))
   {
      if (!FileExists(AppDir+"QS.dsk")) reg->WriteString("AppDir",AppDir);
      reg->WriteInteger("WindowState",(int)WindowState);
      if (WindowState != wsMaximized)
         winpos = AnsiString(Left)+","+AnsiString(Top)+","+
                  AnsiString(Width)+","+AnsiString(Height);
      reg->WriteString("WindowPos",winpos);
   }
   delete reg;

   if (IsEncrypted())
   {
      if (FileDateTime(AppDat)!=DatTime && !SecureData(MasterPassword))
         ShowMessage("Problem: Unable to secure data!");
      else
         simplewipe(AppDat);
   }
   delete MasterPassword;
   SafeStoreMixRandBin();
}
//---------------------------------------------------------------------------
__fastcall TMainForm::~TMainForm()
{
   MixPoolClear();
   if (hMixLib) FreeLibrary(hMixLib);
   if (hSSLLib) FreeLibrary(hSSLLib);
   if (hPgpLib) FreeLibrary(hPgpLib);
   if (hPopLib) FreeLibrary(hPopLib);
   if (!RunProgramOnExit.IsEmpty())
   {
      Sleep(200);
      Exec95(RunProgramOnExit);
   }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ShowHint(TObject *Sender)
{
   StatusBar->Panels->Items[0]->Text = Application->Hint;
}
//---------------------------------------------------------------------------
bool __fastcall TMainForm::SecureData(TDataBuf *password)
{
   bool ok = false;
   if (FileExists(AppPgpTmp)) remove(AppPgpTmp.c_str()); // 1 in a million
   if (FileExists(AppPgp)) rename(AppPgp.c_str(),AppPgpTmp.c_str());

   if (PgpEncryptFile(password,AppDat,PgpExt)==mrOk && FileExists(AppPgp))
   {
      if (FileExists(AppPgpBak)) remove(AppPgpBak.c_str());
      rename(AppPgpTmp.c_str(),AppPgpBak.c_str());
      ok = true;
   }
   else
      rename(AppPgpTmp.c_str(),AppPgp.c_str());

   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall TMainForm::UnSecureData(TDataBuf *password)
{
   int ret;
   bool ok = false;
   if (!FileExists(AppPgp)) return ok;

   ret = PgpDecryptFile(password,AppPgp,DatExt);
   if (ret!=mrOk || !FileExists(AppDat))
      password->Clear();
   else
      ok = true;

   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall TMainForm::IsEncrypted()
{
   return (MasterPassword!=NULL && !MasterPassword->IsEmpty());
}
//---------------------------------------------------------------------------
/*bool __fastcall TMainForm::DotIniKeyExists(AnsiString &Key)
{
   TStringList *inits = new TStringList();
   GetAppData(inits,UserNotes+PS+".ini");
   AnsiString init = inits->Values[Key];
   if (init.SubString(1,1)=="\"") init = init.SubString(2,64);
   if (init.SubString(init.Length(),1)=="\"") init = init.SubString(1,init.Length()-1);
   delete inits;
//   if (ini.Length() && ini[ini.Length()]!="\\"; init += "\\";
//   if (ini.Length()
//      putenv(AnsiString(Key+"="+init));
//   putenv(AnsiString("MIXPATH="));
   return !init.IsEmpty();
}
bool __fastcall TMainForm::MixRegKeyExists()
{
//   AnsiString dir = DotIniKeyExists("MixDir");
   return false;
}*/
//---------------------------------------------------------------------------
bool __fastcall TMainForm::CheckRegkeyExists()
{
   bool ok = true;
   if (!RegKeyExists(QuickKey))
   {
      MsgBoxHwnd(NULL,
         AppName+"'s registry entries are missing. "+
        "You must install, or re-install,\nthe program! "+
        "If you currently have an application data file, "+
        "'"+ExtractFileName(AppDat)+"', it will\nbe preserved through a re-install.",
         AppName+" Error",
         MB_OK
      );
      ok = false;
   }
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall TMainForm::CheckAppiniExists()
{
   if (!FileExists(AppIni))
   {
      AnsiString appini = ExtractFileName(AppIni);
      MsgBoxHwnd(NULL,
        AppName+"'s '"+appini+"' file is missing. You will need to replace\n"+
        "it from the distribution zip file you installed the program from.\n\n"+
        "Clue: Though the file you downloaded had a '.exe'\n"+
        "extension, it was, in fact, a self-extracting ZIP file. To\n"+
        "extract just the '"+appini+"' file, open the distribution zip file with\n"+
        "a zip program, such as Winzip, and extract just '"+appini+"'.\n"+
        "Then place that file in "+AppName+"'s home directory.\n\n"+
        "Alternatively, you can simply re-install "+AppName+" to the\n"+
        "same directory as before. That will solve the problem and\n"+
        "your current data file will be preserved.",
        AppName+" Ini Error",
        MB_OK
      );
      return false;
   }
   return true;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SetNoPgp()
{
   PgpMenu->Visible = false;
   HelpQuickPgpItem->Visible = false;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SetNoPop3()
{
   CheckMailBtn->Visible = false;
   for (int i=0; i<Panel1->ControlCount; i++)
      if (Panel1->Controls[i]->Left > CheckMailBtn->Left)
          Panel1->Controls[i]->Left -= CheckMailBtn->Width;
   InBoxBtn->Visible = false;
   for (int i=0; i<Panel1->ControlCount; i++)
      if (Panel1->Controls[i]->Left > InBoxBtn->Left)
          Panel1->Controls[i]->Left -= InBoxBtn->Width;
   FileCheckMailItem->Visible = false;
   ToolsPopAccountsItem->Visible = false;
   FileSMTPLogItem->Visible = true;
   FileSessionLogsItem->Visible = false;
   MailboxInboxItem->Visible = false;
   ClipboardReceiveItem->Visible = false;
   ClipboardN1Item->Visible = false;
   HelpQuickPop3Item->Visible = false;
   HelpN12Item->Visible = false;
}
//---------------------------------------------------------------------------
HINSTANCE __fastcall TMainForm::CheckQSPop3Install()
{
   HINSTANCE hpoplib = LoadLibrary(AnsiString(AppDir+QSpop3Name).c_str());
   if (!hpoplib) SetNoPop3();
   return hpoplib;
}
//---------------------------------------------------------------------------
HINSTANCE __fastcall TMainForm::CheckQSPgpInstall()
{
   HINSTANCE hpgplib = LoadLibrary(AnsiString(AppDir+QSpgpName).c_str());
   if (!hpgplib) SetNoPgp();
   PgpMenu->Visible = false; // <-temporary til pgp more complete
   return hpgplib;
}
//---------------------------------------------------------------------------
/*HINSTANCE __fastcall TMainForm::CheckUPDateInstall()
{
   HINSTANCE hupdlib = LoadLibrary(AnsiString(AppDir+"qsupd.dll").c_str());
   if (!hupdlib) SetNoUpdate();
   return hupdlib;
}*/
//---------------------------------------------------------------------------
// the update wizard has become part of QS. Not a plugin.
void __fastcall TMainForm::SetNoUpdate()
{
   HelpUpdateItem->Visible = false;
}
//---------------------------------------------------------------------------
bool __fastcall TMainForm::HasUpd()
{
   return true; //hUpdLib>0;
}
//---------------------------------------------------------------------------
HINSTANCE __fastcall TMainForm::CheckMixmasterInstall(bool &shutdown)
{
   AnsiString mixdir;
   HINSTANCE HMixLib=NULL;//,HSSLLib=NULL;
   bool neededmix = !RegKeyExists(MixKey);
   AnsiString appdir = ExtractFilePath(AppExeName); //GetCurrentDir();
   if (neededmix && MixZipExists() && RunMixmasterInstall()==mrOk)
   {
      shutdown = true;
      return NULL;
   }
   if (!RegKeyExists(MixKey))
   {
      MsgBoxHwnd(NULL,
         AnsiString("Unable to locate mixmaster registry key!\n")+
         AnsiString("Remailer chaining and secure mode will not be available.\n\n")+
         AnsiString("If you place 'mix29b12.zip' (or higher) in "+AppName+"'s\n")+
         AnsiString("home directory, and start "+AppName+" again, mixmaster\n")+
         AnsiString("will be installed automatically!"),
         AppName,
         MB_OK
      );
   }
   else
   {
      TRegistry *reg = new TRegistry();
      if (reg->OpenKey(MixKey,false)) mixdir = reg->ReadString("MixDir");
      delete reg;

      SetCurrentDir(mixdir);
      if (!FileExists(MixCfg))
      {  // make sure we have a mix.cfg!
         TStringList *cfg = new TStringList();
         GetAppData(cfg,MixValues+PS+MixClientCfg); // get one stored in appdat
         if (!cfg->Count) cfg->Add(DefMixCfg);  // use hardcode version
         cfg->SaveToFile(MixCfg);
         delete cfg;
      }
/*    if (FileExists("libeay32.dll")) sm("YES"); else sm("NO");
      if ((HSSLLib=LoadLibrary("libeay32.dll"))==NULL)
      {
         MsgBoxHwnd(NULL,
            AnsiString("Unable to locate libeay32.dll.\n")+
            AnsiString("System Error: "+GetLastErrorStr()+"\n\n")+
            AnsiString("Remailer chaining and secure mode will not be available.\n\n")+
            AnsiString("Mixmaster DLL's must be in either a directory listed in\n")+
            AnsiString("your computer's PATH statement OR in "+AppName+"'s home\n")+
            AnsiString("directory, (need not be listed in PATH)"),
            AppName,
            MB_OK
         );
      }
      if (HSSLLib && (HMixLib=LoadLibrary("mixlib.dll"))==NULL)
*/    if ((HMixLib=LoadLibrary("mixlib.dll"))==NULL)
      {
         MsgBoxHwnd(NULL,
            AnsiString("Unable to locate mixlib.dll.\n")+
            AnsiString("System Error: "+GetLastErrorStr()+"\n\n")+
            AnsiString("Remailer chaining and secure mode will not be available.\n\n")+
            AnsiString("Mixmaster DLL's must be in either a directory listed in\n")+
            AnsiString("your computer's PATH statement OR in "+AppName+"'s home\n")+
            AnsiString("directory, (need not be listed in PATH)"),
            AppName,
            MB_OK
         );
      }
   }

   if (GetCurrentDir()!=appdir) SetCurrentDir(appdir);
   return HMixLib;
}
//---------------------------------------------------------------------------
bool __fastcall TMainForm::CheckMixrndExists()
{
   if (!RegKeyExists(MixKey)) return true;

   bool ok = true; TDataBuf *buf = new TDataBuf();
   AnsiString randpool = MixValues+PS+AppRandPool;
   // make sure mixrand.bin has been saved in ini file
   if (FileExists(MixRandBin) && !AppBinaryExists(randpool,buf,AppIni))
   {
      buf->LoadFromFile(MixRandBin);
      PutAppBinary(randpool,buf,AppIni);
   }
   // if no mixrand.bin attemp to restore from ini file OR dat file
   if (!FileExists(MixRandBin) &&
      (AppBinaryExists(randpool,buf,AppIni) || AppBinaryExists(randpool,buf)))
   {
      buf->SaveToFile(MixRandBin);
   }
   delete buf;
   // no mixrand.bin and no backup...
   if (!FileExists(MixRandBin) && !AppBinaryExists(randpool,NULL,AppIni))
   {
      MsgBoxHwnd(NULL,
         "Mixmaster's file 'mixrand.bin' is missing. You'll need to reinstall mixmaster!. Make sure the latest version of Mix's zip file is in the "+AppName+" home directory, and restart "+AppName+".",
          AppName,
          MB_OK
      );
      // remove regkey so that program will install mixmaster, next startup
      // if mixmaster zip is quicksilver dir. leave mix files.
      if (RegKeyExists(MixKey))
      {
         TRegistry *reg = new TRegistry();
         reg->DeleteKey(MixKey);
         delete reg;
      }
      ok = false;
   }
   return ok;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SetNoMixmaster()
{
   FileSecureModeItem->Enabled = false;
   ViewErrLogItem->Enabled = false;
   ViewMixcfgItem->Enabled = false;
   ViewPubringMixItem->Enabled = false;
   ViewMListTxtItem->Enabled = false;
   ViewType2ListItem->Enabled = false;
   ViewPubringAscItem->Enabled = false;
   ViewRListTxtItem->Enabled = false;
   ToolsRemailersItem->Enabled = false;
   ToolsUpdateonSendItem->Enabled = false;
   ToolsUpdateonSendItem->Checked = false;
   RemailerBtn->Enabled = false;
   UpdateStatsBox->Enabled = false;
   UpdateStatsBox->Checked = false;
}
//---------------------------------------------------------------------------
bool __fastcall TMainForm::MixZipExists()
{
   return GetFilenames(NULL,AppDir+"mix29*.zip") || GetFilenames(NULL,AppDir+"mix3*.zip");
}
//---------------------------------------------------------------------------
//bool __fastcall TMainForm::HasMixmaster()
//{
//   return RegKeyExists(MixKey) && hMixLib!=NULL;
//}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ShowInitValues()
{
  // Show the initialization values
  TStringList *init1 = new TStringList();
  TStringList *init2 = new TStringList();
  GetAppData(init1,AppIniValues);
  init1->Insert(0,"[Internal]");
  init2->LoadFromFile(AppIni);
  init1->Add("");
  init1->AddStrings(init2);
  ShowMessage(init1->Text);
  delete init2;
  delete init1;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormDestroy(TObject *Sender)
{
   AnsiString unzipApp = AppDir+UnzipApp;
   if (FileExists(unzipApp)) DeleteFile(unzipApp.c_str());
   if (hMixLib) FreeLibrary(hMixLib);
   delete HeadMan;
   delete ErrorLog;
   delete ProcessLog;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WMQueueChange(TMessage& Msg)
{
   OpenQueueBtn->Enabled = AppDataExists(MailQueue);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WMProblemChange(TMessage& Msg)
{
   OpenProbsBtn->Enabled = AppDataExists(ProblemQueue);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WMUpdateChecked(TMessage& Msg)
{
   Msg.Result=0;
   if (ToolsUpdateonSendItem->Checked)
   {
      AnsiString laststr;
      double minbetween,last=0,curr=(double)Now();
      switch (Msg.WParam)
      {
         case 0:
            minbetween=GetAppIni(StatsMinUpdates,"").ToIntDef(0);
            laststr = GetAppIni("LastStatsTime","");
            if (!laststr.IsEmpty()) last = laststr.ToDouble();
            Msg.Result = last==0 || curr-last>=minbetween/1440;
            //tmp=minbetween/1440; sm(AnsiString(curr-last)+"\n"+AnsiString(tmp));
            break;
         case 1:
            PutAppIni("LastStatsTime",AnsiString((double)curr));
            break;
      }
   }
}
//void __fastcall TMainForm::WMUpdateChecked(TMessage& Msg)
//{
//   Msg.Result = ToolsUpdateonSendItem->Checked ? 1 : 0;
//}
//---------------------------------------------------------------------------
void  __fastcall TMainForm::WMUpdateEnable(TMessage& Msg)
{
   ToolsUpdateonSendItem->Enabled = (bool)Msg.WParam;
   UpdateStatsBox->Enabled = (bool)Msg.WParam;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WMCheckUpdate(TMessage& Msg)
{
   if (ToolsUpdateonSendItem->Checked!=(bool)Msg.WParam)
       ToolsUpdateonSendItem->Click();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::UpdateStatsBoxClick(TObject *Sender)
{
   if (ToolsUpdateonSendItem->Checked != UpdateStatsBox->Checked)
       ToolsUpdateonSendItem->Click();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WMInsertFilename(TMessage& Msg)
{
   TTextWin *tw = dynamic_cast<TTextWin*>(ActiveMDIChild);
   if (tw && OpenDialog->Execute())
       tw->Editor->SelText = OpenDialog->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WMSetButtons(TMessage& Msg)
{
   SetMenus(Msg.WParam);
//   bool sel = Msg.LParam > 0;
   if (Msg.WParam)//enable
   {
//      EditUndoItem->Enabled = true;
//      EditCutItem->Enabled = sel;
//      EditCopyItem->Enabled = sel;
//      EditPasteItem->Enabled = Clipboard()->HasFormat(CF_TEXT);
//      EditSelectAllItem->Enabled = true;

//      CutBtn->Enabled = sel;
//      CopyBtn->Enabled = sel;
//      PasteBtn->Enabled = Clipboard()->HasFormat(CF_TEXT);
//      SetMenus();
   }
   else
   {
//      EditUndoItem->Enabled = false;
//      EditCutItem->Enabled = false;
//      EditCopyItem->Enabled = false;
//      EditPasteItem->Enabled = false;
//      EditSelectAllItem->Enabled = false;

//      PasteBtn->Enabled = false;
//      CopyBtn->Enabled = false;
//      CutBtn->Enabled = false;
//      SetMenus(false);
   }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WMGetErrorLog(TMessage& Msg)
{
   AnsiString entry,MixLog = MixDir()+"errlog";
   if (!FileExists(MixLog)) return;
   TStringList *newEntries = new TStringList();
   switch (Msg.WParam)
   {
      case 0: ErrorLog->LoadFromFile(MixLog); break;     // load errorlog on 0
      case 1:     // success, load errorlog into newentries...
      {           // any new entries since load on 0
         newEntries->LoadFromFile(MixLog);   // show the lines to the user
         for (int i=ErrorLog->Count; i<newEntries->Count; i++)
         {
            entry = newEntries->Strings[i];
            SmtpForm->Display->Lines->Add("Mixmaster reports: "+entry);
         }
         ErrorLog->Text = newEntries->Text;
         break;
      }
      case 2:
      {
         newEntries->LoadFromFile(MixLog);
         for (int i=ErrorLog->Count; i<newEntries->Count; i++)
         {
            entry = newEntries->Strings[i];
            SmtpForm->Display->Lines->Add("Mix Error: "+entry);
         }
         ErrorLog->Text = newEntries->Text;
         break;
      }
   }
   delete newEntries;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WMDisplayXY(TMessage& Msg)
{
   AnsiString display("            ");
   if (Msg.LParam>=0)
      display = AnsiString((int)Msg.LParam)+"/"+AnsiString((int)Msg.WParam);
   StatusBar->Panels->Items[1]->Text = display;
}
//---------------------------------------------------------------------------
/*void __fastcall TMainForm::WMOpenHelp(TMessage& Msg)
{
   AnsiString sec,tit,params((char*)Msg.LParam);
   sec = GetParam(0,params,";");
   tit = GetParam(1,params,";");
   OpenHelpModal(sec,tit);
}*/
//---------------------------------------------------------------------------
void __fastcall TMainForm::WMOpenProblems(TMessage& Msg)
{
   FileProblemsItem->Click();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WMOpenQueue(TMessage& Msg)
{
   FileOpenQueueItem->Click();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WMLoadMailboxMenu(TMessage& Msg)
{
   LoadMailboxMenu();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WMOpenAddresses(TMessage& Msg)
{
   ToolsAddressBookItem->Click();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WMStorePoplog(TMessage& Msg)
{
   TStringList *log = new TStringList();
   log->SetText((char*)Msg.LParam);
   SavePOP3Log((WORD)Msg.WParam,log);
   delete log;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WMOpenInbox(TMessage& Msg)
{
   MailboxWin = OpenMailbox("inbox");
   MailboxWin->MailGrid->RefreshIndex();
   MailboxWin->MailGrid->ClearSelected();
   MailboxWin->GoNewMessages();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WMSetWinCursor(TMessage& Msg)
{
   Cursor = (TCursor)Msg.WParam;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WMIncomingMail(TMessage& Msg)
{
   TStringList *msg = new TStringList();
   msg->SetText((char*)Msg.LParam);
   if (msg->Count)
      PutAppData(UserMailboxes+PS+"inbox"+PS+HeadMan->InIndexString(msg),msg);
   Msg.Result = 1;
   delete msg;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WMPopAccounts(TMessage& Msg)
{
   TStringList *poppers = new TStringList();
   switch (Msg.WParam)
   {
      case 0:
         GetAppData(poppers,PopAccounts);
         Msg.Result = (long)poppers->Text.c_str();
         break;
      case 1:
         poppers->SetText((char*)Msg.LParam);
         PutAppData(PopAccounts,poppers);
         break;
   }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WMDatRequest(TMessage& Msg)
{
   static AnsiString datstr; // for returning data in getdata
   TStringList *data = new TStringList();
   data->SetText((char*)Msg.LParam);
   if (data->Count)
   {
      AnsiString path = data->Strings[0]; data->Delete(0); //path is passes with datalist
      switch (Msg.WParam)
      {
         case GetDatData:
            GetAppData(data,path); datstr = data->Text;
            Msg.Result = (long)datstr.c_str();
//sm(data->Text);
            break;
         case PutDatData:
            PutAppData(path,data);
//sm(data->Text);
            break;
      }
   }
   if (Msg.WParam!=GetDatData) datstr = "";
   delete data;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WMShowStatus(TMessage& Msg)
{
   AnsiString msg = AnsiString((char*)Msg.LParam);
   if (Msg.WParam==0) DisplayStatus(msg,"");
   else DisplayStatus("",msg);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WMSaveQuit(TMessage& Msg)
{
// not working
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WMSecureData(TMessage& Msg)
{
// not working
   switch (Msg.WParam)
   {
      case 1: if (IsEncrypted()) SecureData(MasterPassword); break;
   }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WMHelpWinPos(TMessage& Msg)
{
   AnsiString pos;
   char winpos[32];
   switch (Msg.WParam)
   {
      case 1:
         strcpy(winpos,GetAppIni(HelpWinPos,"").c_str());
         Msg.Result = (long)winpos;
         break;
      case 0:
         if (Msg.LParam!=NULL)
            strcpy(winpos,(char*)Msg.LParam);
         pos = winpos;
         if (!pos.IsEmpty())
            PutAppIni(HelpWinPos,pos);
         break;
   }
}
//---------------------------------------------------------------------------
/*void __fastcall TMainForm::WMEditMenu(TMessage& Msg)
{
   if (Msg.WParam==1)
   {
      EditMenu = Ed0;
      Ed0 = (TMenuItem*)(Msg.LParam);
   }
   else Ed0 = EditMenu;
}*/
//---------------------------------------------------------------------------
void __fastcall TMainForm::SafeStoreMixRandBin()
{
   // store mixrand.bin in appini
   TDataBuf *buf = new TDataBuf();
   if (FileExists(MixRandBin) && !AppBinaryExists(MixValues+PS+AppRandPool,buf,AppIni))
   {
      buf->LoadFromFile(MixRandBin);
      PutAppBinary(MixValues+PS+AppRandPool,buf,AppIni);
   }
   delete buf;
}
//---------------------------------------------------------------------------
//void __fastcall TMainForm::EditTextFile(AnsiString &FileName)
//{
//   TextFileWin = new TTextFileWin(FileName,this);
//}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ViewMenuClick(TObject *Sender)
{
   AnsiString md=MixDir();
   //==disable when no file exists========================
   ViewErrLogItem->Enabled     = HasMix() && FileExists(md+"errlog");
   ViewMListTxtItem->Enabled   = HasMix() && FileExists(md+MListTxt);
   ViewPubringMixItem->Enabled = HasMix() && FileExists(md+MRingTxt);
   ViewType2ListItem->Enabled  = HasMix() && FileExists(md+MTyp2Txt);
   ViewRListTxtItem->Enabled   = HasMix() && FileExists(md+CListTxt);
   ViewPubringAscItem->Enabled = HasMix() && FileExists(md+CRingTxt);
   ViewType1ListItem->Enabled  = HasMix() && FileExists(md+CTyp1Txt);
   // hide type1.list if not error checking mode and has pgp
   bool errcheck = GetAppIni(StatsErrCheck,"").ToIntDef(1);
   ViewType1ListItem->Visible = HasPgp() && errcheck;
   ViewClearItem->Enabled = errcheck;
   //N13->Visible = errcheck;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ViewMixmasterFileItemClick(TObject *Sender)
{
   int pos;
   TMenuItem *item;
   if ((item=dynamic_cast<TMenuItem*>(Sender))!=NULL)
   {
      AnsiString filename = MixDir()+item->Caption;
      while ((pos = filename.Pos("&")) > 0) filename.Delete(pos,1);
      if (!FileExists(filename)) return;
      EditTextFile(filename);
   }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ViewErrLogItemClick(TObject *Sender)
{
   EditTextFile(MixDir()+"errlog");
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ToolsAddressBookItemClick(TObject *Sender)
{
   MessageWin = dynamic_cast<TMessageWin*>(ActiveMDIChild);
   int mode = MessageWin ? modeAddress : modeNoAddress;

   TStringList *rcpts = new TStringList();
   TStringList *grups = new TStringList();
   if (GetMailRecipients(rcpts,grups,mode) && MessageWin)
   {
      int i,pos;
      AnsiString s,hdr;
      bool locked=LockWindowUpdate(Handle);
      TRichEdit *Editor = MessageWin->Editor;

      if (rcpts->Count) // Addresses
      {
         s = rcpts->Text;
         hdr = s.SubString(1,s.Pos(": ")+1).LowerCase();
         if ((pos=HeadMan->Delete(hdr,Editor->Lines))>=0)
         {
            for (i=0; i<rcpts->Count; i++)
               Editor->Lines->Insert(pos+i,rcpts->Strings[i]);
         }
         else
         {
            for (pos=0; pos<Editor->Lines->Count; pos++)
            {
               s = Editor->Lines->Strings[pos].LowerCase();
               if (s.Pos("newsgroups: ")==1 || s.Pos("subject: ")==1 || s.IsEmpty())
               {
                  for (i=0; i<rcpts->Count; i++)
                     Editor->Lines->Insert(pos+i,rcpts->Strings[i]);
                  break;
               }
            }
         }
      }
      if (grups->Count) // Newsgroups
      {
         s = grups->Text;
         hdr = s.SubString(1,s.Pos(": ")+1).LowerCase();
         if ((pos=HeadMan->Delete(hdr,Editor->Lines))>=0)
         {
            for (i=0; i<grups->Count; i++)
               Editor->Lines->Insert(pos+i,grups->Strings[i]);
         }
         else
         {
            for (pos=0; pos<Editor->Lines->Count; pos++)
            {
               s = Editor->Lines->Strings[pos].LowerCase();
               if (s.Pos("newsgroups: ")==1 || s.Pos("subject: ")==1 || s.IsEmpty())
               {
                  for (i=0; i<grups->Count; i++)
                     Editor->Lines->Insert(pos+i,grups->Strings[i]);
                  break;
               }
            }
         }
      }
      MessageWin->SetCursor();
      if (locked) LockWindowUpdate(0);
   }
   delete grups;
   delete rcpts;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ToolsRemailersItemClick(TObject *Sender)
{
   GetRemailerStats(this);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ToolsUpdateonSendItemClick(TObject *Sender)
{
   bool checked = !ToolsUpdateonSendItem->Checked;
   ToolsUpdateonSendItem->Checked = checked;
   if (UpdateStatsBox->Checked != checked) UpdateStatsBox->Checked = checked;
   PutAppIni(IniUpdateOnSend,(checked ? "1" : "0"));
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::MailboxMailboxesItemClick(TObject *Sender)
{
   OpenMailboxes();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::MailboxItemOnClick(TObject *Sender)
{
   TMenuItem *item;
   if ((item=dynamic_cast<TMenuItem*>(Sender))==NULL) return;

   OpenMailbox(item->Caption);
   LoadMailboxMenu();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::LoadMailboxMenu()
{
   int i,c;
   AnsiString s;
   TMenuItem *newitem;
   TStringList *boxes = new TStringList(); boxes->Sorted = true;
   GetAppData(boxes,MailboxBoxmenu);
   int precount = boxes->Count;
   i=0; while (i<boxes->Count)
   {
      s = boxes->Strings[i];
      if (s.IsEmpty() || s==UserMailboxes || s=="outbox" || (HasPop3() && s=="inbox"))
         boxes->Delete(i); else i++;
   }
   // test box list against list of all current boxes, delete if not there.
   TStringList *allboxes = new TStringList();
   GetAppData(allboxes,UserMailboxes);
   i=0; while (i<boxes->Count)
   {
      if (allboxes->IndexOf(boxes->Strings[i])<0)
         boxes->Delete(i); else i++;
   }
   if (boxes->Count!=precount) PutAppData(MailboxBoxmenu,boxes);
   delete allboxes;
   c = HasPop3() ? 5 : 5; // the number of lines (above divider) on mailbox menu
   while (MailboxMenu->Count>c) MailboxMenu->Delete(c);
   for (i=0; i<boxes->Count; i++)
   {
      newitem = new TMenuItem(this);
      newitem->OnClick = MailboxItemOnClick;
      newitem->Caption = boxes->Strings[i];
      MailboxMenu->Add(newitem);
   }
   delete boxes;
}
//---------------------------------------------------------------------------
int eoh(TStrings *msg)
{
   int e=0; while (e<msg->Count && !msg->Strings[e].IsEmpty()) e++;
   return e;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ClipboardReplyItemClick(TObject *Sender)
{
   ClipboardReply(UseDialog);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ClipboardFollowupItemClick(TObject *Sender)
{
   ClipboardFollowup(UseDialog);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileNewMessageItemClick(TObject *Sender)
{
   AnsiString blank;
   bool locked = false; //LockWindowUpdate(GetDesktopWindow());
   try
   {
      TStringList *msg = new TStringList();
      GetAppData(msg,DefaultMessage);
      MessageWin = new TMessageWin(msg,blank,blank,this);
      delete msg;
   }
   catch (...)
   {
      if (locked) LockWindowUpdate(0);
   }
   if (locked) LockWindowUpdate(0);
}
void __fastcall TMainForm::NewMessage()
{
   FileNewMessageItem->Click();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileNewArticleItemClick(TObject *Sender)
{
   AnsiString blank;
   bool locked = false; //LockWindowUpdate(GetDesktopWindow());
   try
   {
      TStringList *art = new TStringList();
      GetAppData(art,DefaultArticle);
      MessageWin = new TMessageWin(art,blank,blank,this);
      MessageWin->Type = tNewArticle;
      delete art;
   }
   catch (...)
   {
      if (locked) LockWindowUpdate(0);
   }
   if (locked) LockWindowUpdate(0);
}
void __fastcall TMainForm::NewArticle()
{
   FileNewArticleItem->Click();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileNewBugReportClick(TObject *Sender)
{
   int idx=0;
   AnsiString blank,TemplateName;
   if ((TemplateName=GetMergeMessage("Create Bug Report using...",modeMessage)).IsEmpty()) return;

   TStringList *msg = new TStringList();
   GetAppData(msg,TemplateName);
   for (int i=0; i<msg->Count; i++)
   {
      if (msg->Strings[i].LowerCase().Pos("to:")==1)
          msg->Strings[i] = "To: "+BugReportAddress;
      if (msg->Strings[i].LowerCase().Pos("subject:")==1)
          msg->Strings[i] = "Subject: Bug Report";
   }
   msg->Add(""); msg->Add("");
   for (int i=0; i<msg->Count; i++)
   {
      if (msg->Strings[i].IsEmpty())
      {
         idx=i; break;
      }
   }
   msg->Insert(++idx,"It happened when I...");
   msg->Insert(++idx,"");
   msg->Insert(++idx,"I got an error message that said...");
   msg->Insert(++idx,"");
   msg->Insert(++idx,"Version Info------------");
   msg->Insert(++idx,AppName+" "+ReleaseVer);
   if (HasPop3())
   {
      AnsiString pop3dll = AnsiString(GetPop3Version());
      if (pop3dll.IsEmpty()) pop3dll = ".9b1";
      msg->Insert(++idx,"QSpop3      "+pop3dll);
   }
   if (HasPgp())
   {
      AnsiString pgpdll = AnsiString(GetPgpLibVersion());
      msg->Insert(++idx,"QSpgp       "+pgpdll);
   }
   msg->Insert(++idx,"");
   bool locked = false; //LockWindowUpdate(GetDesktopWindow());
   try
   {
      MessageWin = new TMessageWin(msg,blank,blank,this);
      delete msg;
   }
   catch (...)
   {
      if (locked) LockWindowUpdate(0);
   }
   if (locked) LockWindowUpdate(0);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::HelpAboutItemClick(TObject *Sender)
{
   ShowAboutBox(this);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileSecureModeItemClick(TObject *Sender)
{
   AnsiString pswd;
   bool cancel=FileSecureModeItem->Checked;
   if (PGPgetSecureModePassphrase(cancel,pswd))
   {
      MasterPassword->SetData(pswd.c_str(),pswd.Length());
      for (int i=1; i<=pswd.Length(); i++) pswd[i] = ' '; pswd = "";
      if (!MasterPassword->IsEmpty())
      {
         MsgBox("Ok, you're in Secure Mode!","QuickSilver",MB_OK);
         DatTime = 0;
//       Close();
      }
   }
   else
   {
      if (cancel)
      {
         MsgBox("Secure Mode cancelled!","QuickSilver",MB_OK);
         MasterPassword->Clear();
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FilePackDatabaseItemClick(TObject *Sender)
{
   PackDatabase();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileSave(AnsiString Section)
{
   AnsiString path;
   if ((TextWin=dynamic_cast<TTextWin*>(ActiveMDIChild))!=NULL)
   {
      path = GetSaveMessagePath(Section,TextWin->Name());
      if (!path.IsEmpty())
      {
         PutAppData(path,TextWin->Editor->Lines);
         // reload note
         TextWin->Editor->Clear();
         Application->ProcessMessages(); Sleep(100);
         GetAppData(TextWin->Editor->Lines,path);
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileOpen(AnsiString Section)
{
   AnsiString blank="";
   TStringList *tmp = new TStringList();
   AnsiString name = OpenOpenDlg(tmp,Section);
   if (name.IsEmpty()) { delete tmp; return; }

   if (Section==ProblemQueue)
   {
      // remove 'Word-Wrap: ' header, if present
      THeaderManager *hm = new THeaderManager(tmp);
      hm->Delete(WordWrapHeader);
      delete hm;

      MessageWin = new TMessageWin(tmp,blank,blank,this);
      MessageWin->DataKey = "";
      PutAppData(ProblemQueue+PS+name,NULL);
      OpenProbsBtn->Enabled = AppDataExists(ProblemQueue);
      DisplayStatus("Message removed from queue!");
      MessageWin->Editor->Modified = true;
      MessageWin->Type = tNewMessage;
      MyBeep(MB_OK);
   }
   else
   if (Section==MailQueue)
   {
      // remove 'Word-Wrap: ' header, if present
      THeaderManager *hm = new THeaderManager(tmp);
      hm->Delete(WordWrapHeader);
      delete hm;

      MessageWin = new TMessageWin(tmp,blank,blank,this);
      MessageWin->DataKey = "";
      PutAppData(MailQueue+PS+name,NULL);
      OpenQueueBtn->Enabled = AppDataExists(MailQueue);
      DisplayStatus("Message removed from queue!");
      MessageWin->Editor->Modified = true;
      MessageWin->Type = tNewMessage;
      MyBeep(MB_OK);
   }
   else
   if (Section==UserTemplates)
   {
      MessageWin = new TMessageWin(tmp,Section,name,this);
      MessageWin->DataKey = UserTemplates+PS+name;
      MessageWin->Caption = UserTemplates+": "+name;
      MessageWin->Type = tTemplate;
   }
   else
   if (Section==UserMessages)
   {
      MessageWin = new TMessageWin(tmp,Section,name,this);
      MessageWin->DataKey = UserMessages+PS+name;
      MessageWin->Caption = UserMessages+": "+name;
      MessageWin->Type = tDraft;
   }
   else
   if (Section==UserNotes)
   {
      NoteWin = new TNoteWin(this);
      NoteWin->DataKey = UserNotes+PS+name;
      NoteWin->SetText(name,tmp);
      NoteWin->Type = tNote;
   }
   delete tmp;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ViewLastSMTPLogItemClick(TObject *Sender)
{
   ReportWin = new TReportWin(ProcessLog,AnsiString("SMTP Process Log"),this);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileOpenDataItemClick(TObject *Sender)
{
   FileOpen(UserData);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileOpenQueueItemClick(TObject *Sender)
{
   FileOpen(MailQueue);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileProblemsItemClick(TObject *Sender)
{
   FileOpen(ProblemQueue);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileNotesItemClick(TObject *Sender)
{
   FileOpen(UserNotes);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileTemplatesItemClick(TObject *Sender)
{
   FileOpen(UserTemplates);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileOpenItemClick(TObject *Sender)
{
   FileOpen(UserMessages);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileExitItemClick(TObject *Sender)
{
   Close();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileSaveAsItemClick(TObject *Sender)
{
   if ((TextWin=dynamic_cast<TTextWin*>(ActiveMDIChild))!=NULL)
      TextWin->SaveAs();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileSaveItemClick(TObject *Sender)
{
   if ((TextWin=dynamic_cast<TTextWin*>(ActiveMDIChild))!=NULL)
      TextWin->Save();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FilePrintItemClick(TObject *Sender)
{
   if ((TextWin=dynamic_cast<TTextWin*>(ActiveMDIChild))!=NULL)
      TextWin->Print();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileNewNoteItemClick(TObject *Sender)
{
   bool locked = false;//LockWindowUpdate(GetDesktopWindow());
   try
   {
      NoteWin = new TNoteWin(this);
      NoteWin->Caption = newNote;
   }
   catch (...)
   {
      if (locked) LockWindowUpdate(0);
   }
   if (locked) LockWindowUpdate(0);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileQueueItemClick(TObject *Sender)
{
   if ((MessageWin=dynamic_cast<TMessageWin*>(ActiveMDIChild))!=NULL)
      MessageWin->Queue();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WMSendMail(TMessage& Msg)
{
   if (AppDataExists(MailQueue))
   {
     ((TMessageWin*)Msg.LParam)->Close();
      SendTimer->Enabled = true;
   }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SendTimerTimer(TObject *Sender)
{
   SendTimer->Enabled = false;
   SendMail();
   Perform(WM_UPDATEENABLE,HasMix()?1:0,NULL);
 // wparam = enable/disable UpdateBox
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileSendMessageItemClick(TObject *Sender)
{
   if ((MessageWin=dynamic_cast<TMessageWin*>(ActiveMDIChild))!=NULL)
      MessageWin->Send();
   else
   if (AppDataExists(MailQueue))
      SendMail();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileSaveAsDefMessageItemClick(TObject *Sender)
{
   if ((MessageWin=dynamic_cast<TMessageWin*>(ActiveMDIChild))!=NULL)
      MessageWin->SaveDefMessage();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileSaveAsDefArticleItemClick(TObject *Sender)
{
   if ((MessageWin=dynamic_cast<TMessageWin*>(ActiveMDIChild))!=NULL)
      MessageWin->SaveDefArticle();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SetMenus(bool children)
{
   if (!children || !MDIChildCount)
   {
      bool queued = AppDataExists(MailQueue);
      if (queued) FileSendMessageItem->Caption = "Send Queued &Messages"; else
         FileSendMessageItem->Caption = "Send &Mail Now";
      FileSendMessageItem->Enabled = queued;

      FileQueueItem->Enabled = false;
      FileSaveItem->Enabled = false;
      FileSaveAsItem->Enabled = false;
      FileSaveAsTemplateItem->Enabled = false;
      FileSaveAsDefaultItem->Enabled = false;
      FilePrintItem->Enabled = false;
   }
   else
   if ((MessageWin=dynamic_cast<TMessageWin*>(ActiveMDIChild))!=NULL)
   {
      FileSendMessageItem->Enabled = true;
      FileQueueItem->Enabled = true;
      FileSaveAsTemplateItem->Enabled = true;
      FileSaveAsDefaultItem->Enabled = true;
      FileSaveItem->Enabled = true;
      FileSaveAsItem->Enabled = true;
      FilePrintItem->Enabled = true;
   }
   else
   if ((TextWin=dynamic_cast<TTextWin*>(ActiveMDIChild))!=NULL)
   {
      FileSendMessageItem->Enabled = false;
      FileQueueItem->Enabled = false;
      FileSaveAsTemplateItem->Enabled = false;
      FileSaveAsDefaultItem->Enabled = false;
      FileSaveItem->Enabled = true;
      FileSaveAsItem->Enabled = true;
      FilePrintItem->Enabled = true;
   }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileMenuClick(TObject *Sender)
{
   FileSMTPLogItem->Enabled = AppDataExists(SMTPLog);
   SessionLogsPOP3Item->Enabled = AppDataExists(POP3Log);
   FileOpenQueueItem->Enabled = AppDataExists(MailQueue);
   FileProblemsItem->Enabled = AppDataExists(ProblemQueue);
   FileTemplatesItem->Enabled = AppDataExists(UserTemplates);
   FileMiscMessagesItem->Enabled = AppDataExists(UserMessages);
   FileNotesItem->Enabled = AppDataExists(UserNotes);
   //FileNymsItem->Enabled = AppDataExists(UserNyms);
   FileSecureModeItem->Checked = !MasterPassword->IsEmpty();
   //if (!RegKeyExists(MixKey) || !hMixLib) FileSecureModeItem->Enabled = false;

   TRichEdit *Editor = NULL;
   MessageWin=NULL; TextWin=NULL; TextFileWin=NULL;
   if ((MessageWin=dynamic_cast<TMessageWin*>(ActiveMDIChild))!=NULL)
      Editor = MessageWin->Editor;
   else
   if ((TextFileWin=dynamic_cast<TTextFileWin*>(ActiveMDIChild))!=NULL)
      Editor = TextFileWin->Editor;
   else
   if ((TextWin=dynamic_cast<TTextWin*>(ActiveMDIChild))!=NULL)
      Editor = TextWin->Editor;
   if (!Editor) return;

   bool hasText = Editor->Lines->Count;
   FilePrintItem->Enabled = hasText;
   if (MessageWin)
   {
      FileSaveItem->Enabled = !MessageWin->Name().IsEmpty() && Editor->Modified;
      FileSaveAsItem->Enabled = hasText;
   }
   if (TextFileWin)
   {
      FileSaveItem->Enabled = Editor->Modified;
      FileSaveAsItem->Enabled = false;
   }
   if (TextWin)
   {
      FileSaveItem->Enabled = !TextWin->Name().IsEmpty() && Editor->Modified;
      FileSaveAsItem->Enabled = hasText;
   }

   int queued = (int)AppDataExists(MailQueue);
   if (!queued && !MessageWin)
      FileSendMessageItem->Caption = "Send &Mail Now";
   else
   if ( queued && !MessageWin)
      FileSendMessageItem->Caption = "Send Queued &Mail Now";
   else
   if (!queued &&  MessageWin)
      FileSendMessageItem->Caption = "Send &Message Now";
   else
   if ( queued &&  MessageWin)
      FileSendMessageItem->Caption = "Send &Mail Now";

   FileSendMessageItem->Enabled = queued || MessageWin;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WindowItemClick(TObject *Sender)
{
   TMenuItem *item;
   if ((item=dynamic_cast<TMenuItem*>(Sender))!=NULL)
   {
      switch(item->Tag)
      {
         case 1: ArrangeIcons(); break;
         case 2: Cascade(); break;
         case 3: Tile(); break;
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WindowMenuClick(TObject *Sender)
{
   WindowTileItem->Enabled = MDIChildCount>0;
   WindowCascadeItem->Enabled = MDIChildCount>0;
   WindowArrangeIconsItem->Enabled = MDIChildCount>0;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileSaveAsTemplateItemClick(TObject *Sender)
{
   if ((MessageWin=dynamic_cast<TMessageWin*>(ActiveMDIChild))!=NULL)
      MessageWin->SaveAsTemplate();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EditBtnClick(TObject *Sender)
{
   TOfficeButton *but;
   if ((TextWin=dynamic_cast<TTextWin*>(ActiveMDIChild))==NULL) return;
   if ((but=dynamic_cast<TOfficeButton*>(Sender))==NULL) return;
   switch (but->Tag)
   {
      case 1: TextWin->EditCutItem->Click(); break;
      case 2: TextWin->EditCopyItem->Click(); break;
      case 3: TextWin->EditPasteItem->Click(); break;
   }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::StatusBarResize(TObject *Sender)
{
   StatusBar->Panels->Items[0]->Width = Width-150;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DisplayStatus(AnsiString &status, AnsiString &other)
{
   StatusBar->Panels->Items[0]->Text = status;
// StatusBar->Panels->Items[1]->Text = other;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ClipboardMenuClick(TObject *Sender)
{
   bool enable = Clipboard()->HasFormat(CF_TEXT);
   ClipboardReplyItem->Enabled = enable;
   ClipboardFollowupItem->Enabled = enable;
   ClipboardReceiveItem->Enabled = enable;
/*
   ClipboardReplyItem->Enabled = false;
   ClipboardFollowupItem->Enabled = false;
   if (Clipboard()->HasFormat(CF_TEXT))
   {
      TMemo *m = new TMemo((void*)NULL);
      m->WordWrap = false;
      m->Visible = false;
      m->Parent = this;
      m->PasteFromClipboard();
      HeadMan->HereIs(m->Lines);
      if(HeadMan->Has("Newsgroups: ") || HeadMan->Has("Followup-To: "))
         ClipboardFollowupItem->Enabled = true;
      if (HeadMan->Has("Reply-To: ") || HeadMan->Has("From: "))
         ClipboardReplyItem->Enabled = true;
      delete m;
   }
*/
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Panel1Resize(TObject *Sender)
{
/*
   TControl *c;
   int i,tmp,left=0;
   for (i=0; i<Panel1->ControlCount; i++)
   {
      if ((c=dynamic_cast<TSpeedButton*>(Panel1->Controls[i]))==NULL) continue;
      tmp = c->Left+c->Width+68;
      if (tmp>left) left=tmp;
   }
   if (Panel1->Width>left)
      UpdateStatsBox->Left = Panel1->Width-68;
*/
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::HelpGettingStartedItemClick(TObject *Sender)
{
   GetStarted(AppDir+"QuickStart.rtf");
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::HelpQuickPop3ItemClick(TObject *Sender)
{
   GetStarted(AppDir+"QuickStart.Pop3.rtf");
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::HelpQuickPgpItemClick(TObject *Sender)
{
   GetStarted(AppDir+"QuickStart.Pgp.rtf");
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormMouseMove(TObject *Sender, TShiftState Shift,
  int X, int Y)
{
   rnd_mouse(WM_MOUSEMOVE,0,MAKELONG(X,Y));
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Preferences1Click(TObject *Sender)
{
   GetPreferences();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::MailboxOutboxItemClick(TObject *Sender)
{
   OpenMailbox("outbox");
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::MailboxInboxItemClick(TObject *Sender)
{
   OpenMailbox("inbox");
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::MailboxNewItemClick(TObject *Sender)
{
   AnsiString newname = CreateMailbox();
   if (!newname.IsEmpty()) OpenMailbox(newname);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SessionLogsErrorCheckItemClick(TObject *Sender)
{
   TStringList *log = new TStringList();
   AnsiString title = OpenOpenDlg(log,ErrChkLog,!sorted);
   if (!title.IsEmpty())
      ReportWin = new TReportWin(log,title,Application->MainForm);
   delete log;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileSMTPLogItemClick(TObject *Sender)
{
   TStringList *log = new TStringList();
   AnsiString title = OpenOpenDlg(log,SMTPLog,!sorted);
   if (!title.IsEmpty())
      ReportWin = new TReportWin(log,title,Application->MainForm);
   delete log;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FilePOP3LogItemClick(TObject *Sender)
{
   TStringList *log = new TStringList();
   AnsiString title = OpenOpenDlg(log,POP3Log,!sorted);
   if (!title.IsEmpty())
      ReportWin = new TReportWin(log,title,Application->MainForm);
   delete log;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ViewChainLogClick(TObject *Sender)
{
   NoteWin = new TNoteWin(ChainLog,"Mixmaster Chain Log",this);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SavePOP3Log(WORD count, TStrings *log)
{
   TStringList *list = new TStringList();
   GetAppData(list,POP3Log);
   int max = GetAppIni(POP3LogMax,"").ToIntDef(16);
   while (max && list->Count>=max)
   {
      PutAppData(POP3Log+PS+list->Strings[0],NULL);
      list->Delete(0);
   }
   AnsiString logstr=SMTPPOP3logtime()+" "+log->Strings[log->Count-1];
   PutAppData(POP3Log+PS+logstr,log);
   delete list;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::CheckBtnClick(TObject *Sender)
{
   GetPop3Mail(this,Application->Handle,false); // in QSpop.dll
}
void __fastcall TMainForm::FileCheckMailItemClick(TObject *Sender)
{
   GetPop3Mail(this,Application->Handle,false); // in QSpop.dll
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ClipboardReceiveItemClick(TObject *Sender)
{
   TMemo *m = new TMemo((void*)NULL);
   m->Visible = false;
   m->WordWrap = false;
   m->Parent = this;
   m->PasteFromClipboard();
   THeadMan *head = new THeadMan(m->Lines);
   if ((head->Has("From: ") || head->Has("Reply-To:")) && head->Has("To: "))
   {
      AnsiString idxstr = head->InIndexString(m->Lines);
      PutAppData(UserMailboxes+PS+"inbox"+PS+idxstr,m->Lines);
      OpenMessageIn("inbox",idxstr);
   }
   else
   {
      MsgBox(
         AnsiString("Clipboard does not appear to contain\n")+
         AnsiString("an email message!"),
         AnsiString("Can't Receive Clipboard"),
         MB_OK
      );
      TextWin = new TTextWin(this);
      TextWin->SetText("Clipboard Contents...",m->Lines);
   }
   delete head;
   delete m;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::HelpUpdateItemClick(TObject *Sender)
{
#ifndef QSMOBILE
   bool cancel;
   RunProgramOnExit = RunUpdateExpress(this,cancel);
   if (cancel) Show(); else Close();
#endif
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ToolsPopAccountsItemClick(TObject *Sender)
{
   GetPop3Mail(this,Application->Handle,true); // in QSpop.dll
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::HelpMenuClick(TObject *Sender)
{
   HelpGettingStartedItem->Enabled = FileExists(AppDir+QuickStart);
   HelpQuickPop3Item->Visible = FileExists(AppDir+QuickStartPop3);
   HelpQuickPgpItem->Visible = FileExists(AppDir+QuickStartPgp);
#ifdef QSMOBILE
   HelpGettingStartedItem->Visible = false;
   HelpQuickPop3Item->Visible = false;
   HelpUpdateItem->Visible = false;
   HelpN12Item->Visible = false;
   HelpN7Item->Visible = false;
#endif
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Timer1Timer(TObject *Sender)
{
   Timer1->Enabled = false;
   if (HasPgp())
   {
      if (PgpPublicRing().IsEmpty() || PgpSecretRing().IsEmpty())
      {
         MsgBox(
            s("I see you have the QuickSilver PGP plugin installed, but QS\n")+
            s("is unable to locate your pgp keyrings. I'll open the Options\n")+
            s("Dialog so you can locate these yourself."),
            s("QuickSilver PGP"),
             MB_OK
         );
         GetPreferences("pgp");
         return;
      }
      AnsiString pub=PgpPublicRing(),sec=PgpSecretRing(),imp=PgpImportRing();
      if (FileExists(imp))
      {
         MsgBox(
            s("I have detected a new PGP export keyring file. I'll open\n")+
            s("the Import Keys Dialog"),
            s("QS PGP Import Keys"),
             MB_OK
         );
         GetPreferences("pgp");
         return;
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ToolsOptionsItemsClick(TObject *Sender)
{
   GetPreferences();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::InBoxBtnClick(TObject *Sender)
{
   OpenMailbox("inbox");
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::OfficeButton5Click(TObject *Sender)
{
   OpenMailbox("outbox");
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::OptionsBtnClick(TObject *Sender)
{
   GetPreferences();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ViewClearItemClick(TObject *Sender)
{
   ClearChosenDocuments(this);  
}
//---------------------------------------------------------------------------
