//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\registry.hpp>
#pragma hdrstop

#include "PassDlg.h"
#include "FileMan.h"
#include "Global.h"
#include "MixmastDlg.h"
#include "fmxutils.h"
#include "version.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TDataBuf *MasterPassword;
TPassForm *PassForm;
//---------------------------------------------------------------------------
int __fastcall GetUserPassphrase(int mode, TDataBuf *password)
{
// password->Clear();
   TPassForm *PF = new TPassForm(Application->MainForm);
   PF->SetMode(mode);
   PF->ShowModal();
   int result = PF->ModalResult;
   switch (result)
   {
      case mrAbort:
         password->Clear();
         break;
      case mrOk   :
         password->Set(PF->pswrd->Text.c_str(),PF->pswrd->Text.Length());
         password->Encrypt(BUFWORD);
         break;
   }
   delete PF;
   return result;
}
//---------------------------------------------------------------------------
__fastcall TPassForm::TPassForm(TComponent* Owner)
	: TForm(Owner)
{
   CheckBox1->Checked = true;
//   TRegistry *reg = new TRegistry();
//   if (reg->OpenKey(QuickKey,false)) CheckBox1->Checked = reg->ReadBool("Hide Password");
//   delete reg;
   pswrd->PasswordChar = CheckBox1->Checked ? '*' : '\0';
   cnfrm->PasswordChar = pswrd->PasswordChar;
   SecureNow = false;
   mode = mdEncrypt;
   password = NULL;
   ok = true;
}
//---------------------------------------------------------------------------
void __fastcall TPassForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   ok = true;
   if ((mode==mdEncrypt || mode==mdEncryptedNow || mode==mdConventional) && ModalResult==mrOk)
   {
      if (pswrd->Text.IsEmpty())
      {
         ShowMessage("Both passphrase fields are required. Please try again.");
         ClearTexts(); ActiveControl = pswrd;
         CanClose = false;
         ok = false;
         return;
      }
      if (pswrd->Text != cnfrm->Text)
      {
         ShowMessage("Passphrase entries do not match. Please try again.");
         ClearTexts(); ActiveControl = pswrd;
         CanClose = false;
         ok = false;
         return;
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TPassForm::FormDestroy(TObject *Sender)
{
   ClearTexts();
}
//---------------------------------------------------------------------------
void __fastcall TPassForm::ClearTexts()
{
   int i;
   for (i=1; i<=pswrd->Text.Length(); i++) pswrd->Text[i] = '\0';
   pswrd->Clear();
   for (i=1; i<=cnfrm->Text.Length(); i++) cnfrm->Text[i] = '\0';
   cnfrm->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TPassForm::CheckBox1Click(TObject *Sender)
{
   pswrd->PasswordChar = CheckBox1->Checked ? '*' : '\0';
   cnfrm->PasswordChar = pswrd->PasswordChar;
//   TRegistry *reg = new TRegistry();
//   if (reg->OpenKey(QuickKey,false)) reg->WriteBool("Hide Password",CheckBox1->Checked);
//   delete reg;
   ActiveControl = pswrd;
}
//---------------------------------------------------------------------------
void __fastcall TPassForm::MemoChange(TObject *Sender)
{
   if (mode==mdEncryptNymCnfg) return;

   Label3->Visible = SecureNow && mode==mdEncryptedNow &&
      pswrd->Text.IsEmpty() && cnfrm->Text.IsEmpty();
}
//---------------------------------------------------------------------------
void __fastcall TPassForm::SetMode(int Mode)
{
   mode = Mode;
   switch (mode)
   {
      case mdEncryptedNow:
         CancelBtn1->Visible = true;
         Label3->Visible = true;
      case mdConventional:
         Caption = "Passphrase For Convential Encryption";
         // fall through
      case mdEncrypt:
   	    Label2->Visible = true; cnfrm->Visible = true;
         break;
      case mdEncryptNymCnfg:
         Caption = "Nym Database Password";
         break;
      case mdDecrypt:
    	    cnfrm->Visible = false; Label2->Visible = false;
         OkBtn->Top = 88; CancelBtn->Top = 88;
         Height = 150;
         break;
   }
}
//---------------------------------------------------------------------------
bool __fastcall SecureData(TDataBuf *password)
{
   bool ok = false;
   if (FileExists(AppPgpTmp)) remove(AppPgpTmp.c_str()); // 1 in a million
   if (FileExists(AppPgp)) rename(AppPgp.c_str(),AppPgpTmp.c_str());

   if (PgpEncryptFile(password,AppDat,PgpExt)==mrOk && FileExists(AppPgp))
   {
      if (FileExists(AppPgpBak)) remove(AppPgpBak.c_str());
      rename(AppPgpTmp.c_str(),AppPgpBak.c_str());
      ok = true;
   }
   else
      rename(AppPgpTmp.c_str(),AppPgp.c_str());

   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall UnSecureData(TDataBuf *password)
{
   int ret;
   bool ok = false;
   if (!FileExists(AppPgp)) return ok;

   ret = PgpDecryptFile(password,AppPgp,DatExt);
   if (ret!=mrOk || !FileExists(AppDat))
      password->Clear();
   else
      ok = true;

   return ok;
}
//---------------------------------------------------------------------------
void __fastcall TPassForm::CancelBtn1Click(TObject *Sender)
{
   if (MsgBoxHwnd(Handle,
      AnsiString("You have asked to remove password encryption from your QS database\n\n")+
      AnsiString("Are you sure?"),"Cancel Secure Mode",MB_YESNO)==IDYES)
   {
      MsgBox("Secure mode cleared!","QuickSilver",MB_OK);
      ModalResult = mrAbort;
   }
}
//---------------------------------------------------------------------------
