//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "pgpmail.h"
#include "fileman.h"
#include "headman.h"
#include "global.h"
HINSTANCE hPgpLib=NULL;
//---------------------------------------------------------------------------
bool __fastcall HasPgp()
{
   return hPgpLib!=NULL;
}
//---------------------------------------------------------------------------
int __fastcall QSPoolNext()
{
   int next = GetAppIni("QSPoolNext","").ToIntDef(0)+1;
   PutAppIni("QSPoolNext",s(next));
   return next;
}
//---------------------------------------------------------------------------
int __fastcall QSPoolCount()
{
   TStringList *pool = new TStringList();
   GetAppData(pool,QSPoolKey);
   int count = pool->Count;
   delete pool;
   return count;
}
//---------------------------------------------------------------------------
int __fastcall QSPoolAdd(TStrings *Msg, AnsiString &Name)
{
   PutAppData(QSPoolKey+PS+Name,Msg);
   return QSPoolCount();
}
//---------------------------------------------------------------------------
int __fastcall QSPoolRemove(AnsiString &Name)
{
   PutAppData(QSPoolKey+PS+Name,NULL);
   return QSPoolCount();
}
//---------------------------------------------------------------------------
void __fastcall QSPoolClear()
{
   TStringList *pool = new TStringList();
   GetAppData(pool,QSPoolKey);
   for (int i=0; i<pool->Count; i++)
      PutAppData(QSPoolKey+PS+pool->Strings[i],NULL);
   PutAppData(QSPoolKey,NULL);
   delete pool;
}
//---------------------------------------------------------------------------
int __fastcall QSPoolGet(TStrings *Msg, AnsiString &Name, bool Remove)
{
   GetAppData(Msg,QSPoolKey+PS+Name);
   if (Remove) QSPoolRemove(Name);
   return QSPoolCount();
}
//---------------------------------------------------------------------------
bool  __fastcall QSPoolHeaderToClearText(int &ClearText, TStrings *msg)
{
   THeaderManager *hm = new THeaderManager(msg);
   ClearText=hm->GetDat(ClrTextHdr).ToIntDef(0);
   hm->Delete(ClrTextHdr);
   return ClearText>0;
}
//---------------------------------------------------------------------------
bool  __fastcall QSPoolClearTextToHeader(TStrings *msg, int ClearText)
{
   if (ClearText>0) msg->Insert(0,ClrTextHdr+s(ClearText));
   return ClearText>0;
}
//---------------------------------------------------------------------------
void  __fastcall PgpInit(HINSTANCE HMixLib, HINSTANCE HSSLLib, TForm *MainForm,
   HWND AppHandle)
{
   PGPINIT pgpinit;
   if ((pgpinit = (PGPINIT)GetProcAddress(hPgpLib,"@PgpInit"))!=NULL)
      (pgpinit)(HMixLib,HSSLLib,MainForm,AppHandle);
}
//---------------------------------------------------------------------------
bool  __fastcall PgpImportKeysReplace(char *importfile, char *pubring,
   char *secring, bool deleteImportfile)
{
   PGP_IMPORTREPLACE pgp_importreplace;
   if ((pgp_importreplace = (PGP_IMPORTREPLACE)GetProcAddress(hPgpLib,"@PgpImportKeysReplace"))!=NULL)
      return (bool)(pgp_importreplace)(importfile,pubring,secring,deleteImportfile);
   return false;
}
//---------------------------------------------------------------------------
bool  __fastcall PgpImportKeysAddNew(char *importfile, char *pubring,
   char *secring, bool deleteImportfile)
{
   PGP_IMPORTADDNEW pgp_importaddnew;
   if ((pgp_importaddnew = (PGP_IMPORTADDNEW)GetProcAddress(hPgpLib,"@PgpImportKeysAddNew"))!=NULL)
      return (bool)(pgp_importaddnew)(importfile,pubring,secring,deleteImportfile);
   return false;
}
//---------------------------------------------------------------------------
char* __fastcall PgpSignMessage(char *Message)
{
   PGP_SIGNMESSAGE pgp_signmessage;
   if ((pgp_signmessage = (PGP_SIGNMESSAGE)GetProcAddress(hPgpLib,"@PgpSignMessage"))!=NULL)
      return (char*)(pgp_signmessage)(Message);
   return NULL;
}
//---------------------------------------------------------------------------
char* __fastcall PgpEncryptMessage(char *Message)
{
   PGP_ENCRYPTMESSAGE pgp_encryptmessage;
   if ((pgp_encryptmessage = (PGP_ENCRYPTMESSAGE)GetProcAddress(hPgpLib,"@PgpEncryptMessage"))!=NULL)
      return (char*)(pgp_encryptmessage)(Message);
   return NULL;
}
//---------------------------------------------------------------------------
char* __fastcall PgpEncryptSignMessage(char *Message)
{
   PGP_ENCRYPTSIGNMESSAGE pgp_encryptsignmessage;
   if ((pgp_encryptsignmessage = (PGP_ENCRYPTSIGNMESSAGE)GetProcAddress(hPgpLib,"@PgpEncryptSignMessage"))!=NULL)
      return (char*)(pgp_encryptsignmessage)(Message);
   return NULL;
}
//---------------------------------------------------------------------------
bool __fastcall PgpIsConventional(char* Message)
{
   PGP_ISCONVENTIONAL pgp_isconventional;
   if ((pgp_isconventional = (PGP_ISCONVENTIONAL)GetProcAddress(hPgpLib,"@PgpIsConventional"))!=NULL)
      return (bool)(pgp_isconventional)(Message);
   return false;
}
//---------------------------------------------------------------------------
char* __fastcall PgpDecryptVerifyMessage(char *Message)
{
   PGP_DECRYPTVERIFYMESSAGE pgp_decryptverifymessage;
   if ((pgp_decryptverifymessage = (PGP_DECRYPTVERIFYMESSAGE)GetProcAddress(hPgpLib,"@PgpDecryptVerifyMessage"))!=NULL)
      return (char*)(pgp_decryptverifymessage)(Message);
   return NULL;
}
//---------------------------------------------------------------------------
char* __fastcall PgpGetUserIdsKeyIds(char *KeyFile)
{
   PGP_GETKEYS_IDS pgp_getkeys_ids;
   if ((pgp_getkeys_ids = (PGP_GETKEYS_IDS)GetProcAddress(hPgpLib,"@PgpGetUserIdsKeyIds"))!=NULL)
      return (char*)(pgp_getkeys_ids)(KeyFile);
   return NULL;
}
//---------------------------------------------------------------------------
/*bool  __fastcall GenerateType1List(char *KeyDoc)
{
   GENERATETYPE1LIST generatetype1list;
   if ((generatetype1list = (GENERATETYPE1LIST)GetProcAddress(hPgpLib,"@GenerateType1List"))!=NULL)
      return (generatetype1list)(KeyDoc);
   return NULL;
}*/
//---------------------------------------------------------------------------
char* __fastcall PgpGetNewRemailerKeys(char *KeyDoc, char *Type1)
{
   PGP_GETNEWKEYS pgp_getnewkeys;
   if ((pgp_getnewkeys = (PGP_GETNEWKEYS)GetProcAddress(hPgpLib,"@PgpGetNewRemailerKeys"))!=NULL)
      return (pgp_getnewkeys)(KeyDoc,Type1);
   return NULL;
}
//---------------------------------------------------------------------------
char* __fastcall PgpAddNewRemailerKeys(char *KeyDoc, char *Type1)
{
   PGP_ADDNEWKEYS pgp_addnewkeys;
   if ((pgp_addnewkeys = (PGP_ADDNEWKEYS)GetProcAddress(hPgpLib,"@PgpAddNewRemailerKeys"))!=NULL)
      return (pgp_addnewkeys)(KeyDoc,Type1);
   return "";
}
//---------------------------------------------------------------------------
char* __fastcall PgpArmorBlockToArmorKeys(char *Keys)
{
   PGP_GETARMORKEYS pgp_getarmorkeys;
   if ((pgp_getarmorkeys = (PGP_GETARMORKEYS)GetProcAddress(hPgpLib,"@PgpArmorBlockToArmorKeys"))!=NULL)
      return (pgp_getarmorkeys)(Keys);
   return "";
}
//---------------------------------------------------------------------------
char* __fastcall PgpArmorKeysToArmorBlock(char *Keys)
{
   PGP_PUTARMORKEYS pgp_putarmorkeys;
   if ((pgp_putarmorkeys = (PGP_PUTARMORKEYS)GetProcAddress(hPgpLib,"@PgpArmorKeysToArmorBlock"))!=NULL)
      return (pgp_putarmorkeys)(Keys);
   return "";
}
//---------------------------------------------------------------------------
char* __fastcall GetPgpLibName()
{
   GET_PGPLIBNAME getpgplibname;
   if ((getpgplibname = (GET_PGPLIBNAME)GetProcAddress(hPgpLib,"@GetPgpLibName"))!=NULL)
      return (getpgplibname)();
   return "";
}
//---------------------------------------------------------------------------
char* __fastcall GetPgpLibVersion()
{
   GET_PGPLIBVERSION getpgplibversion;
   if ((getpgplibversion = (GET_PGPLIBVERSION)GetProcAddress(hPgpLib,"@GetPgpLibVersion"))!=NULL)
      return (getpgplibversion)();
   return "";
}
//---------------------------------------------------------------------------



